SetAttributes[
  {OutLine,Outline,UseBG,Permanent},Constant];

AutoLoad[EyePoint,ListBirdsEyePlot,
  ListPlot3D,PackagesDirectory//"Canvas3D.n"];

AutoLoad[ChooseAxis,PackagesDirectory//"ChooseAxis.n"];
AutoLoad[CanvasCM,PackagesDirectory//"CanvasCM.n"];

CanvasFrame=Class[{},{},
  {PlotRange={Automatic,Automatic},
    PlotRegion={{0,1},{0,1}},
    Frame=True,
    FrameTicks={True,True,Ticks,Ticks},
    FrameLabel={"","","",""},
    GridLines={None,None},
    Scale={Linear,Linear},
    AspectRatio=GoldenRatio,
    Origin={0,0},
    $Scale={1,1},
    WindowScale={1,1},
    GraphicsList={},
    LegendList={},
    ID=0,
    FrameClick->True,
    InfoLabel->True},

  Constructor[]:=();

  SetScale[]:=();

  Show[]:=();

  Redraw[]:=();

  ];

CanvasGraphics=Class[{},

  {$DefaultWindowWidth=9.6,
    $DefaultWindowHeight=9.6/GoldenRatio,
    $DefaultWindowOrigin={2.4,1.8},
    $DefaultCanvasSize={13,10},
    $DefaultCanvasAspectRatio=13/10,
    EPS=1e-300,
    CanvasObject},

  {DPI=72,
    Canvas$PlotRange={{0,1},{0,1}},
    Canvas$PlotRegion={{0,1},{0,1}},
    Canvas$Window=CanvasGraphics@$DefaultWindowOrigin+
      {{0,CanvasGraphics@$DefaultWindowWidth},
        {0,CanvasGraphics@$DefaultWindowWidth/GoldenRatio}},
    Canvas$RawWindow=CanvasGraphics@$DefaultWindowOrigin+
      {{0,CanvasGraphics@$DefaultWindowWidth},
        {0,CanvasGraphics@$DefaultWindowWidth/GoldenRatio}},
    RawWindowSize,
    WindowSize,
    StartID,
    CanvasLastID,
    CanvasLastID1,
    Canvas$IDList={},
    GraphicsList={},
    AllGraphics={},
    Canvas$Initialize=True,
    Canvas$Axes={Linear,Linear},
    Canvas$Origin=CanvasGraphics@$DefaultWindowOrigin,
    LegendList,
    LegendPos,
    WindowList,
    Canvas$PlotLabel,
    DefaultOption={},
    EffectiveRange,
    EffectiveAxes,
    EffectiveGL,
    Canvas$Offset,
    Canvas$Scale,
    YOrg,XMax,Margin={{0.02,0.98},{0.02,0.98}},
    Canvas$Coord,
    Canvas$Coord1,
    Canvas$GCoord,
    CoordLimited,    
    CoordLimitedX,
    CoordLimitedY,
    StandardScale,
    PlotSymbolSize,
    WindowCoord,
    Canvas$Range,
    RawWindowAspectRatio=GoldenRatio,
    CanvasAspectRatio=13/10,
    Canvas$Frame, Canvas$FrameCallBack,
    WindowID,
    CCM=Null,
    DragZ,DragZ0,DragTag,DragDo,DragStart,DragMove,DragRelease,

    Canvas$Symbol,
    CanvasWidget,
    CanvasPathName,
    DefaultTitleSize
    },

  If[Order[{8,1},Tk$Version]>=0,
    Constructor[Widget[c_,__]]:=(
      CanvasWidget=c;
      DefaultTitleSize=Switch[$FontSystem,
	"Xft",	16,
	_,	18];
      CanvasPathName=TkPathName[c];
      With[{n$=CanvasPathName,
        p$=TkCanvasPointer[CanvasPathName],
        oval$=CanvasTypeID["oval"],
        poly$=CanvasTypeID["polygon"],
        line$=CanvasTypeID["line"],
        rect$=CanvasTypeID["rectangle"]},
        Canvas$Symbol[x__]:=(
          CanvasSymbolDirect[p$,x,Canvas$Range,
            If[Canvas$Axes[[2]]===Log,
              Canvas$Range[[2]],
              Canvas$Offset],
            oval$,poly$,rect$,line$]);
        CanvasLastID:=TkCanvasLastItem[p$]];
      RawWindowAspectRatio=StandardAspectRatio[]),

    Constructor[Widget[c_,__]]:=(
      CanvasWidget=c;
      CanvasPathName=TkPathName[c];
      With[{n$=CanvasPathName},
        Canvas$Symbol[x__]:=Tcl[CanvasSymbol[n$,x,Canvas$Range]];
        CanvasLastID:=(
          CanvasLastID1=
            If[#==={},0,
              Max[First[#],CanvasLastID1]]&
              [CanvasWidget[Find$Below[Floor[2E9]]]])];
      RawWindowAspectRatio=StandardAspectRatio[]);

    ];

  StandardAspectRatio[]:=(
    CanvasAspectRatio=Divide@@CanvGeo[];
    Min[GoldenRatio*CanvasAspectRatio/$DefaultCanvasAspectRatio,
      GoldenRatio+CanvasAspectRatio-$DefaultCanvasAspectRatio]);

  CanvGeo[]:=Module[{{w,h}=WidgetInfo[CanvasWidget,{Width,Height}]},
    If[w<4,
      CanvasWidget[CGet[Width,Height]],
      {w,h}]];

  Choose[]:=(
    Clear[The$Canvas];
    The$Canvas=CanvasWidget);

  SetCanvas$Scale[align_]:=(
    Module[{g=CanvGeo[],scale},
      DPI=Switch[align,
        Automatic,
!        Floor[Max[g/$DefaultCanvasSize]],
        Floor[g[[2]]/$DefaultCanvasSize[[2]]],
        Horizontal,
        Floor[g[[1]]/$DefaultCanvasSize[[1]]],
        Vertical,
        Floor[g[[2]]/$DefaultCanvasSize[[2]]]];
      {XMax,YOrg}=g/DPI;
      scale=g/(DPI*$DefaultCanvasSize);
      RawWindowSize=$DefaultWindowWidth*{1,1/RawWindowAspectRatio}*scale[[1]];
      Canvas$Origin=$DefaultWindowOrigin*scale;
      Canvas$RawWindow=Canvas$Origin+Thread[{{0,0},RawWindowSize}]];
    StandardScale=Sqrt[DPI/72];
    PlotSymbolSize=4*StandardScale;
    Canvas$Scale=DPI*{1,-1}*
      ((WindowSize=Apply[(#2-#1)&,Canvas$Window,{1}])/
        (Max[#,1e-100]&/@Abs[#1-#2])&@@Thread[Canvas$PlotRange]);
    Canvas$Offset=DPI*
      ({1,-1}*Canvas$Window[[,1]]+{0,YOrg})
    -Canvas$PlotRange[[,1]]*Canvas$Scale;
    With[{Canvas$Offset,Canvas$Scale,DPI,Canvas$PlotRange,
      YOrg},
      Canvas$Coord1[x_]:=Round[Canvas$Offset+x*Canvas$Scale];
      WindowCoord[{x_,y_}]:=
        Round[{x,YOrg-y}*DPI];
      Clear[Canvas$GCoord];
      Switch[Canvas$Axes,
        {Linear|Date,Linear|Date},
        Canvas$Coord[x_]:=Round[Canvas$Offset+x*Canvas$Scale];
        Canvas$GCoord[x_]:=x;
        CoordLimitedX[x_]:=
          Restrict[x,Canvas$PlotRange[[1,1]],Canvas$PlotRange[[1,2]]];
        CoordLimitedY[x_]:=
          Restrict[x,Canvas$PlotRange[[2,1]],Canvas$PlotRange[[2,2]]],

        {Linear|Date,Log},
        Canvas$Coord[x_]:=Round[Canvas$Offset+
          {First[x],
            Log[10,Restrict[Second[x],EPS,Infinity]]}*Canvas$Scale];
        Canvas$GCoord[{x_,y_}]:={x,10^y};
        CoordLimitedX[x_]:=
          Restrict[x,Canvas$PlotRange[[1,1]],Canvas$PlotRange[[1,2]]];
        CoordLimitedY[x_]:=
          Restrict[Log[10,Restrict[x,EPS,Infinity]],
            Canvas$PlotRange[[2,1]],Canvas$PlotRange[[2,2]]],

        {Log,Linear|Date},
        Canvas$Coord[x_]:=Round[Canvas$Offset+
          {Log[10,
            Restrict[First[x],EPS,Infinity]],Second[x]}*Canvas$Scale];
        Canvas$GCoord[{x_,y_}]:={10^x,y};
        CoordLimitedX[x_]:=
          Restrict[Log[10,Restrict[x,EPS,Infinity]],
            Canvas$PlotRange[[1,1]],Canvas$PlotRange[[1,2]]];
        CoordLimitedY[x_]:=
          Restrict[x,Canvas$PlotRange[[2,1]],Canvas$PlotRange[[2,2]]],

        {Log,Log},
        Canvas$Coord[x_]:=Round[Canvas$Offset+
          Log[10,Restrict[x,EPS,Infinity]]*Canvas$Scale];
        Canvas$GCoord[x_]:=10^x;
        CoordLimitedX[x_]:=
          Restrict[Log[10,Restrict[x,EPS,Infinity]],
            Canvas$PlotRange[[1,1]],Canvas$PlotRange[[1,2]]];
        CoordLimitedY[x_]:=
          Restrict[Log[10,Restrict[x,EPS,Infinity]],
            Canvas$PlotRange[[2,1]],Canvas$PlotRange[[2,2]]]]];
    Block[{x,y},
      Off[General::wrongtype];
      CoordLimited[{x_,y_}]=Canvas$Coord[{CoordLimitedX[x],
        CoordLimitedY[y]}];
      On[General::wrongtype]
      ];
    Canvas$Range={
      WindowCoord[{Canvas$Window[[1,1]],Canvas$Window[[2,2]]}],
      WindowCoord[{Canvas$Window[[1,2]],Canvas$Window[[2,1]]}]};
    );

  Set$Canvas$Offset[]:=Canvas$Offset;
  Set$Canvas$Offset[x_]:=(Canvas$Offset=x);
  Set$Canvas$Scale[]:=Canvas$Scale;
  Set$Canvas$Scale[x_]:=(Canvas$Scale=x);

  SetupFrame[op_,rect_,scr_,align_]:=First[{
    MakeWindow[rect,AspectRatio/.op/.AspectRatio->Automatic],
    Canvas$Axes=First[scr];
    Canvas$PlotRange=FrameRange2/@MapThread[FrameRange,scr];
    SetEffectiveRange[];
    SetCanvas$Scale[align];
    }];

  FrameRange2[{0,0}]={-0.001,0.001};
  FrameRange2[{min_,min_}]:=MinMax[{min*0.999,min*1.001}];
  FrameRange2[{min_,max_}]:=If[max-min<1e-100,(min+max)/2*{0.999,1.001},{min,max},{min,max}];
!  FrameRange2[{min_,max_}]:=If[min-1e10<max<min,{max,min},{min,max},{min,max}];
  FrameRange2[x_]:=x;
  FrameRange1[Linear|Date,Automatic,x1_,x2_]:=x1+0.07*(x1-x2);
  FrameRange1[Linear|Date,x_,__]:=x;
  FrameRange1[Log,Automatic,x1_,x2_]:=
    Log[10,Max[x1,EPS]]+0.07*Log[10,Max[x1,EPS]/Max[x2,EPS]];
  FrameRange1[Log,x_,__]:=Log[10,Max[EPS,x]];
  FrameRange[s_,{Automatic,Automatic},{b1_,b2_}]:=
    {FrameRange1[s,Automatic,b1,b2],FrameRange1[s,Automatic,b2,b1]};
  FrameRange[s_,{Automatic,r2_},{b1_,_}]:=
    {FrameRange1[s,Automatic,Min[b1,r2],r2],FrameRange1[s,r2,r2,b1]};
  FrameRange[s_,{r1_,Automatic},{_,b2_}]:=
    {FrameRange1[s,r1,r1,b2],FrameRange1[s,Automatic,Max[b2,r1],r1]};
  FrameRange[s_,{r1_,r2_},{__}]:={FrameRange1[s,r1,r1,r2],FrameRange1[s,r2,r2,r1]};

  MakeWindow[Automatic,ar_]:=Module[
    {wxc,wyc,
      {wx1,wx2}=Canvas$RawWindow[[1]],
      {wy1,wy2}=Canvas$RawWindow[[2]],ar0=ar},
    {wx1,wx2}=Restrict[First[Canvas$PlotRegion]*(wx2-wx1)+wx1,XMax*Margin[[1,1]],XMax*Margin[[1,2]]];
    {wy1,wy2}=Restrict[Second[Canvas$PlotRegion]*(wy2-wy1)+wy1,YOrg*Margin[[2,1]],YOrg*Margin[[2,2]]];
    {wxc,wyc}={wx1+wx2,wy1+wy2}/2;
    If[~RealQ[ar0],ar0=RawWindowAspectRatio];
    If[ar0<=CanvasAspectRatio,
      {wx1,wx2}=wxc+(wy2-wy1)*ar0/{-2,2},
      {wy1,wy2}=wyc+(wx2-wx1)/ar0/{-2,2}];
    Canvas$Window={{wx1,wx2},{wy1,wy2}};
    AppendTo[WindowList,Canvas$Window];
    Abs[{wx2-wx1,wy2-wy1}/$DefaultWindowWidth]];

  MakeWindow[{{x1_,y1_},{x2_,y2_}},ar_]:=Module[
    {wxc,wyc,
      {wx1,wx2}=Canvas$RawWindow[[1]],
      {wy1,wy2}=Canvas$RawWindow[[2]],ar0=ar,dar},
    {wx1,wx2}=Restrict[First[Canvas$PlotRegion]*(wx2-wx1)+wx1,XMax*Margin[[1,1]],XMax*Margin[[1,2]]];
    {wy1,wy2}=Restrict[Second[Canvas$PlotRegion]*(wy2-wy1)+wy1,YOrg*Margin[[2,1]],YOrg*Margin[[2,2]]];
    {wx1,wx2}={x1,x2}*(wx2-wx1)+wx1;
    {wy1,wy2}={y1,y2}*(wy2-wy1)+wy1;
    dar=(wx2-wx1)/(wy2-wy1);
    {wxc,wyc}={wx1+wx2,wy1+wy2}/2;
    If[RealQ[ar0],
      If[ar0<=dar,
        {wx1,wx2}=wxc+(wy2-wy1)*ar/{-2,2},
        {wy1,wy2}=wyc+(wx2-wx1)/ar/{-2,2}],
      ar0=dar];
    Canvas$Window={{wx1,wx2},{wy1,wy2}};
    AppendTo[WindowList,Canvas$Window];
    Abs[{wx2-wx1,wy2-wy1}/$DefaultWindowWidth]];

  LegendOffset[_]={0,0};

  CanvasFrameBind[fr_,l_]:=(
    Bind[CanvasWidget,"<Double-Button-1>",
      Canvas$FrameClick[fr,l],Tags->StandardForm[{"F$"//l//fr,"LF$"//l//fr}]];
    CanvasFrameBind[fr,l]=Null);

  With[{def={Tags->False,FrameLabel->{},Frame->True,
    Scale->{Linear,Linear},
    FrameTicks->{True,True,Ticks,Ticks},
    FrameClick->True,
    FrameThickness->Automatic,
    InfoBind->True,
    GridLines->{None,None},
    Alignment->Automatic,
    TickSize->Automatic,
    TickFont->Default,
    PlotLabel->"",Background->"#ffffff"},
    CanvasListVar:={EffectiveRange,EffectiveAxes,EffectiveGL,
      Canvas$PlotRange,Canvas$Axes,
      Canvas$Scale,Canvas$Offset}},

    CanvasDrawer[opt_,list_,init_,w_,rect_,last_,ini_]:=Module[
      {fl,pl,ft,wsx,wsy,wsfx,wsfy,det,wc,fr,tag,t1,t2,addtag,enc,glist,ws,
        pr,id,l1,align,up,ts,frid,fclk,dr,plr,sca,gr,ib,tkf,frt,frt1,
        op=Override[opt,def]},
      {tag,fl,pl,fr,wc,align,pr,fclk,dr,ft,frt,ts,ib,tkf}=
        {Tags,FrameLabel,PlotLabel,Frame,Background,Alignment,
          PlotRegion,FrameClick,DataRange,FrameTicks,FrameThickness,TickSize,
          InfoBind,TickFont}/.op;
      If[w,
        If[ini,
          Canvas$Initialize=init;
          If[init<=>False,
            Canvas$Frame=0;
            WindowList=LegendList={};
            Canvas$PlotRegion=pr]];
        If[Canvas$Initialize===Frame &&
          Canvas$Frame>0 && 
            WindowID[Canvas$Frame]<
              Length[GraphicsList[[Canvas$Frame]]],
          CanvasWidget[Delete]=
            Flatten[
              Range@@[Drop[Canvas$IDList[[Canvas$Frame]],
                WindowID[Canvas$Frame]],{1}]]];
        frid=If[init<=>False,
          ++Canvas$Frame,
          Canvas$Frame];
        If[Length[LegendList]<frid,
          AppendTo[LegendList,{}]];
        If[Length[DefaultOption]<frid,
          AppendTo[DefaultOption,{}]];
        WindowID[frid]=0;
        {plr,sca,gr}=OverrideOptions[frid,op];
        {wsx,wsy}=If[fr || init <=>False,
          SetupFrame[op,rect,{sca,plr,dr},align],
          {1,1}];
        If[Length[GraphicsList]<frid,
          AppendTo[GraphicsList,{}];
          AppendTo[Canvas$IDList,{{0,0}}]],
        frid=Canvas$Frame];

      (* Return Canvas Frame ID to delayed binding symbol with FrameID *)
      If[Length[Select[Flatten[op],
	(Head[#]===RuleDelayed && #[[1]]===FrameID)&]]>0,
	Apply[Set, {Extract[Hold[FrameID]/.op, {1}, Unevaluated], frid}]];

      id=++WindowID[frid];
      glist={{list,opt},CanvasListVar};
      Switch[Canvas$Initialize,
        Frame,
        If[Length[GraphicsList[[frid]]]>=id,
          If[GraphicsList[[frid,id]]===glist,
            l1=Cases[Flatten[{list},1],
              Rectangle[_,_,(_Graphics|_List)..,___],
              {1}];
            Scan[Primitive,l1];
            Return[frid],
            CanvasWidget[Delete]=Range@@Canvas$IDList[[frid,id]]
            ]],
        False,
        If[ini && w,
          Canvas$IDList={{{0,0}}};
          LegendList=GraphicsList={{}}],
        _,
        If[ini && w,
          ClearCanvas[];
          SetupCM[];
          Canvas$PlotLabel=0;
          Canvas$IDList={{{0,0}}};
          LegendList=GraphicsList={{}}]];
      If[Length[GraphicsList[[frid]]]>=id,
        GraphicsList[[frid,id]]=glist;
        Canvas$IDList[[frid,id]]={0,0},
        AppendTo[GraphicsList[[frid]],glist];
        AppendTo[Canvas$IDList[[frid]],{0,0}]];
      StartID=CanvasLastID+1;
      If[w,
        If[Canvas$PlotRange[[1,1]]<Canvas$PlotRange[[1,2]] && 
          Canvas$PlotRange[[2,1]]<Canvas$PlotRange[[2,2]],
          If[StringQ[wc],
            WindowBG[frid,wc,fr,ib]];
          If[fr,
            ft=ExpandFrameTicks[ft];
            ts=Take[Flatten[{ts,ts}],2];
            {wsfx,wsfy}={
              Min[wsx*RawWindowAspectRatio,Max[wsy,wsx]],
              Min[wsy/0.7,Max[wsy,wsx]]};
            frt1=frt/.(Automatic->Min[(Plus@@CanvGeo[])/500*Sqrt[wsfx*wsfy],2]);
            FrameX[First[ft],Third[ft],
              First[ts]/.Automatic->Max[0.15,wsfy^(.4)],First[gr],Sqrt[wsfx],fclk,tkf,frt1];
            FrameY[Second[ft],ft[[4]],
              Second[ts]/.Automatic->Max[0.15,wsfx^(.4)],Second[gr],Sqrt[wsfy],fclk,tkf,frt1];
            fl=Take[Join[fl,{"","","",""}],4];
            fl={fl,{"BOTTOM","LEFT CENTER","TOP","RIGHT CENTER"},
              DefaultTitleSize*(StandardScale*{wsfx,wsfy,wsfx,wsfy})^0.45};
            ScanThread[If[""<=>#<=>{"",""},
              MakeTitle[#,Restrict[#3,9,28],#2]]&,fl]]
          ]];
      If[addtag=(tag<=>False),t1=CanvasLastID+1];
      If[Head[list]===List,
        Scan[Primitive,list],
        Primitive[list]];     
      If[last && frid<=Length[LegendList] &&
        LegendList[[frid]]<=>{},
        Canvas$Legend[frid,Canvas$Range,LegendList[[frid]]];
        LegendList[[frid]]={}];
      If[addtag,
        t2=CanvasLastID;
        If[~NumberQ[tag],
          CanvasWidget[AddTag$Above]={tag,t1-1}]];
      If[Length[Canvas$IDList[[frid]]]>=id,
        Canvas$IDList[[frid,id]]={StartID,CanvasLastID},
        AppendTo[Canvas$IDList[[frid]],
          {StartID,CanvasLastID}]];
      If[w && ""<=>pl<=>{"",""},
        If[Canvas$PlotLabel<=>0,
          CanvasWidget[Delete]=Canvas$PlotLabel];
        MakeTitle[pl,Restrict[DefaultTitleSize*1.5*(wsx*wsy)^(.4),10,32],"TOP HIGH"];
        Canvas$PlotLabel=CanvasLastID
        ];
      StartID=CanvasLastID+1;
      frid]];

  ExpandFrameTicks[Automatic]={True,True,Ticks,Ticks};
  ExpandFrameTicks[{Automatic,l__}]:=ExpandFrameTicks[{True,l}];
  ExpandFrameTicks[{b_,Automatic,t___}]:=ExpandFrameTicks[{b,True,t}];
  ExpandFrameTicks[{b_,l_,Automatic,r___}]:=ExpandFrameTicks[{b,l,Ticks,r}];
  ExpandFrameTicks[{b_,l_,t_,Automatic}]:={b,l,t,Ticks};
  ExpandFrameTicks[{b_}]:={b,True,Ticks,Ticks};
  ExpandFrameTicks[{b_,l_}]:={b,l,Ticks,Ticks};
  ExpandFrameTicks[{b_,l_,t_}]:={b,l,t,Ticks};
  ExpandFrameTicks[b_List]:=b;
  ExpandFrameTicks[b_]:={b,b,b,b};

  SetEffectiveRange[]:=Module[
    {plr1=PlotRange/.DefaultOption[[Canvas$Frame]]},
    EffectiveRange=If[plr1===PlotRange,
      Canvas$PlotRange,
      MapThread[SetPerm2,{plr1,Canvas$PlotRange}]]];

  SetPerm[Permanent[x_],_]:=Permanent[x];
  SetPerm[_,y_]:=y;
  SetPerm2[{Permanent[x1_],Permanent[x2_]},_]:={Permanent[x1],Permanent[x2]};
  SetPerm2[{Permanent[x1_Real],_},{_,y2_Real}]:={Permanent[x1],Max[y2,x1]};
  SetPerm2[{Permanent[x1_],_},{_,y2_}]:={Permanent[x1],y2};
  SetPerm2[{_,Permanent[x2_Real]},{y1_Real,_}]:={Min[y1,x2],Permanent[x2]};
  SetPerm2[{_,Permanent[x2_]},{y1_,_}]:={y1,Permanent[x2]};
  SetPerm2[_,y_]:=y;
  ChoosePerm[Permanent[x_],_]:=x;
  ChoosePerm[_,y_]:=y;
  ChoosePerm2[{Permanent[x1_],Permanent[x2_]},_]:={x1,x2};
  ChoosePerm2[{Permanent[x1_Real],_},{_,y2_Real}]:={x1,Max[y2,x1]};
  ChoosePerm2[{Permanent[x1_],_},{_,y2_}]:={x1,y2};
  ChoosePerm2[{_,Permanent[x2_Real]},{y1_Real,_}]:={Min[y1,x2],x2};
  ChoosePerm2[{_,Permanent[x2_]},{y1_,_}]:={y1,x2};
  ChoosePerm2[_,y_]:=y;

  OverrideOptions[fr_,op_]:=Module[{
    {plr,sca,gr}={PlotRange,Scale,GridLines}/.op,
    {plr1,sca1,gr1}={PlotRange,Scale,GridLines}/.DefaultOption[[fr]]},
    plr=Switch[plr,
      Automatic,
      {{Automatic,Automatic},{Automatic,Automatic}},
      {{__},{__}},plr,
      {{__},Automatic},{First[plr],{Automatic,Automatic}},
      {Automatic,{__}},{{Automatic,Automatic},plr[[2]]},
      {__},{{Automatic,Automatic},plr}];
    If[plr1<=>PlotRange,
      plr=
        MapThread[ChoosePerm2,{plr1,plr}]];
    Switch[sca,
      _Symbol,sca={Linear,sca}];
    gr=gr/.{True->Automatic,False->None};
    gr=Take[Flatten[{gr,gr}],2];
    If[sca1===Scale,
      EffectiveAxes=sca,
      EffectiveAxes=MapThread[SetPerm,{sca1,sca}];
      sca=MapThread[ChoosePerm,{sca1,sca}]];
    If[gr1===GridLines,
      EffectiveGL=gr,
      EffectiveGL=MapThread[SetPerm,{gr1,gr}];
      gr=MapThread[ChoosePerm,{gr1,gr}]];
    {plr,sca,gr}];

  TitlePosition["LEFT CENTER",t_:"L"]:=Module[
    {f=CanvasWidget[BBox[StandardForm[t//"F$Y1"//Canvas$Frame]]],
      e=CanvasWidget[BBox[StandardForm["E"//t//"F$Y1"//Canvas$Frame]]],
      c=WindowCoord[
        {Canvas$Window[[1,1]]-12/DPI,
          (Canvas$Window[[2,1]]+Canvas$Window[[2,2]])/2}]},
    If[f==={},{c,(Canvas$Window[[2,2]]-Canvas$Window[[2,1]])*DPI,"e"},
      {{First[f],Second[c]},f[[4]]-Max[Second[f],If[e<=>{},e[[4]],0]],"e"}]];
  TitlePosition["RIGHT CENTER",t_:"L"]:=Module[
    {f=CanvasWidget[BBox[StandardForm[t//"F$Y2"//Canvas$Frame]]],
      e=CanvasWidget[BBox[StandardForm["E"//t//"F$Y2"//Canvas$Frame]]],
      c=WindowCoord[
        {Canvas$Window[[1,2]]+12/DPI,
          (Canvas$Window[[2,1]]+Canvas$Window[[2,2]])/2}]},
    If[f==={},{c,(Canvas$Window[[2,2]]-Canvas$Window[[2,1]])*DPI,"w"},
      {{Third[f],Second[c]},f[[4]]-Max[Second[f],If[e<=>{},e[[4]],0]],"w"}]];
  TitlePosition["BOTTOM",t_:"L"]:=Module[
    {f=CanvasWidget[BBox[StandardForm[t//"F$X1"//Canvas$Frame]]],
      c=WindowCoord[
        {(Canvas$Window[[1,1]]+Canvas$Window[[1,2]])/2,
          Canvas$Window[[2,1]]-24/DPI}]},
    If[f==={},{c,(Canvas$Window[[1,2]]-Canvas$Window[[1,1]])*DPI,"n"},
      {{First[c],f[[4]]},Third[f]-First[f],"n"}]];
  TitlePosition["TOP",t_:"L"]:=Module[
    {f=CanvasWidget[BBox[StandardForm[t//"F$X2"//Canvas$Frame]]],
      c=WindowCoord[
        {(Canvas$Window[[1,1]]+Canvas$Window[[1,2]])/2,
          Canvas$Window[[2,2]]+4/DPI}]},
    If[f==={},{c,(Canvas$Window[[1,2]]-Canvas$Window[[1,1]])*DPI,"s"},
      {{First[c],Second[f]},Third[f]-First[f],"s"}]];
  TitlePosition["TOP HIGH",t_:"L"]:=Module[
    {f,c=WindowCoord[
        {(Canvas$Window[[1,1]]+Canvas$Window[[1,2]])/2,
          Canvas$Window[[2,2]]+4/DPI}]},
    f=StandardForm[Min[{
      Table[(CanvasWidget[BBox["F$X2"//i]]/.{}->c)[[2]],{i,Length[GraphicsList]}],
      Table[(CanvasWidget[BBox["FL$X2"//i]]/.{}->c)[[2]],{i,Length[GraphicsList]}]}]];
    {{First[c],f},(Canvas$Window[[1,2]]-Canvas$Window[[1,1]])*DPI,"s"}];

  TitleTag["LEFT CENTER"]:=StandardForm["T$LC"//Canvas$Frame];
  TitleTag["RIGHT CENTER"]:=StandardForm["T$RC"//Canvas$Frame];
  TitleTag["BOTTOM"]:=StandardForm["T$B"//Canvas$Frame];
  TitleTag["TOP"]:=StandardForm["T$T"//Canvas$Frame];
  TitleTag["TOP HIGH"]:=StandardForm["T$TH"//Canvas$Frame];
  TitleTag[_]:=Null;

  TitleRotate["LEFT CENTER"]:={Rotation->90,Anchor->"e",Tags->StandardForm["FL$Y1"//Canvas$Frame]};
  TitleRotate["RIGHT CENTER"]:={Rotation->270,Anchor->"w",Tags->StandardForm["FL$Y2"//Canvas$Frame]};
  TitleRotate["BOTTOM"]:={Anchor->"n",Tags->StandardForm["FL$X1"//Canvas$Frame]};
  TitleRotate["TOP"]:={Anchor->"s",Tags->StandardForm["FL$X2"//Canvas$Frame]};
  TitleRotate["TOP HIGH"]:={Anchor->"s",Tags->StandardForm["PL"//Canvas$Frame]};
  TitleRotate[_]:={Anchor->"c"};

  EffectiveStringLength[s_,m_]:=(EffectiveStringLength[s,m]=Module[{p=StringPosition[s,"\n"],s1,l,q,d},
    s1=If[p==={},
      s,
      l=StringLength[s]+1;
      p=Join[{{0,0}},p,{{l,l}}];
      d=Join[{{0,0}},Difference[p]];
      q=Position[d,{Max[d],_},1,1][[1,1]];
      s[p[[q-1,1]]+1,p[[q,1]]-1]];
    Max[StringLength[s1]-Length[StringPosition[s1,"`"]]*2,m]]);

  DefaultSize[t_,w_,size_,pos_,"e"]:=Module[{fl=0,bl},
    StandardForm[
      Do[bl=CanvasWidget[BBox[{"LF$Y2"//i,"FL$Y2"//i,"F$Y2"//i}]];
        If[bl<=>{} && bl[[1]]<pos[[1]] && bl[[2]]<=pos[[2]]<=bl[[4]],
          fl=Max[fl,bl[[3]]]],
        {i,0,Canvas$Frame}]];
    Round[
      Max[9,size*0.7,Min[w/EffectiveStringLength[t,16]*2.2,pos[[1]]-fl-1,size*1.3]]]];
  DefaultSize[t_,w_,size_,pos_,"w"]:=Module[{wc=CanvasWidget[Width],bl,fl},
    fl=wc;
    StandardForm[
      Do[bl=CanvasWidget[BBox[{"LF$Y1"//i,"FL$Y1"//i,"F$Y1"//i}]];
        If[bl<=>{} && bl[[3]]>pos[[1]] && bl[[2]]<=pos[[2]]<=bl[[4]],
          fl=Min[fl,bl[[1]]]],
        {i,0,Canvas$Frame}]];
    Round[
      Max[9,size*0.7,Min[w/EffectiveStringLength[t,16]*2.2,fl-pos[[1]]-1,size*1.3]]]];
  DefaultSize[t_,w_,size_,pos_,"n"]:=Module[{wc=CanvasWidget[Height],bl,fl},
    fl=wc;
    StandardForm[
      Do[bl=CanvasWidget[BBox[{"LF$X2"//i,"FL$X2"//i,"F$X2"//i}]];
        If[bl<=>{} && bl[[4]]>pos[[2]] && bl[[1]]<=pos[[1]]<=bl[[3]],
          fl=Min[fl,bl[[2]]]],
        {i,0,Canvas$Frame}]];
    Round[
      Max[9,size*0.7,Min[w/EffectiveStringLength[t,16]*2.2,fl-pos[[2]]-1,size*1.3]]]];
  DefaultSize[t_,w_,size_,pos_,"s"]:=Module[{fl=0,bl},
    StandardForm[
      Do[bl=CanvasWidget[BBox[{"LF$X1"//i,"FL$X1"//i,"F$X1"//i}]];
        If[bl<=>{} && bl[[2]]<pos[[2]] && bl[[1]]<=pos[[1]]<=bl[[3]],
            fl=Max[fl,bl[[4]]]],
        {i,0,Canvas$Frame}]];
    Round[
      Max[9,size*0.7,Min[w/EffectiveStringLength[t,16]*2.2,pos[[2]]-fl-1,size*1.3]]]];

  MakeTitle["",__]:=Null;
  MakeTitle[t_,size_,p_]:=Module[{{pos,w,anc}=TitlePosition[p],sz},
    sz=DefaultSize[t,w,size,pos,anc];
    CanvasWidget[Create$Text]={pos,Text->t,
      Justify->"center",
      Font->TextFont[sz,$DefaultSansSerifFont,If[sz<10,Null[],"bold"]],
      With[{ttag = TitleTag[p]}, If[ttag <=> Null, Tags->{ttag}, Null[]]],
      Null@@TitleRotate[p],
      UseBG->False}];
  MakeTitle[Text[{t_String,___},opt:((_Rule|_RuleDelayed)...)],size_,p_]:=
    Primitive[Text[{t,CanvasScaled/@(TitlePosition[p][[1]])},opt,
      Justify->"center",
      TextFont:>{Round[size],$DefaultSansSerifFont,If[size<10,Null[],"bold"]},
      With[{ttag = TitleTag[p]}, If[ttag <=> Null, Tags->{ttag}, Null[]]],
      Null@@(TitleRotate[p]/.Rotation->TextRotate),
      UseBG->False]];
  MakeTitle[t_List,size_,p_]:=MakeTitle[First[t],size,p];

  With[{def={Dashing->{1},Plot->False,ErrorBarTickSize->1,
    ErrorBarThickness->1,PlotJoined->True,StepRatio->1,
    PointSize->1,PointSymbol->"1O",PlotColor->"Black",Thickness->1,
    PointBorderColor->Automatic,Legend->False,Arrow->Null,Clip->True,
    LineTags->Null,PointTags->Null,PointColor->"forest green"}},

    Primitive[Line[body_,opt___]]:=Module[
      {pc,pl,pj,sr,size,sym,ebl,ptc,dash,ltag,ptag,thick,pbc,leg,arr,clip,canvr=Canvas$Range,
        bt=Thread[body],op=Override[opt,def],cmd,ebth},
      {pc,pl,pj,sr,size,sym,ebl,ptc,dash,ltag,ptag,thick,pbc,leg,ebth,arr,clip}=
        {PlotColor,Plot,PlotJoined,StepRatio,PointSize,PointSymbol,
	  ErrorBarTickSize,PointColor,Dashing,LineTags,PointTags,Thickness,
          PointBorderColor,Legend,ErrorBarThickness,Arrow,Clip}/.op;
      If[~clip,Canvas$Range={{-Infinity,-Infinity},{Infinity,Infinity}}];
      cmd={Fill->pc,
        If[ltag<=>Null,TagFrame[ltag]=Canvas$Frame;Tags->ltag,Null[]],
        If[arr<=>Null,Arrow->arr,Null[]],
        If[thick<>1,Width->thick,Null[]]};
      Switch[pj,
	Step,  CanvasDrawerLine[cmd, dash, Thread[Canvas$StepData[sr, body]]],
	True,  CanvasDrawerLine[cmd, dash, bt],
	False, (* Broken *)
	  Print["Canvas: Primitive[Line[...]] catch PlotJoined->False"],
	_,     (* Unsupported *)
	];
      If[pl, CanvasDrawerPoints[sym, ptag, ptc, pc, size, pbc, bt]];
      CanvasDrawerErrorBar[ebl * 0.1 * DPI, ebth, pc, bt];
      If[leg<=>False,
        AppendTo[LegendList[[Canvas$Frame]],
          {op,leg}]];
      Canvas$Range=canvr;
      ]];
  Primitive[Line[{},___]]:=Null;

  With[{CanvasW=Extract[CanvasWidget,{1},Unevaluated$]},
    CanvasDrawerErrorBar[ebl_, ebt_, pc_, bt_]:=If[Length[bt]>2,
      Module[{d=Take[bt,2]},
	ScanThread[Canvas$ErrorBar[ebl, ##, {Width->ebt, Fill->pc}]&,
	  Join[Canvas$Coord[d],
	    Canvas$Scale * Canvas$ErrorBarData[Canvas$Axes, bt, d]]];
	]];

    CanvasDrawerLine[cmd_, {1} , bt_] := (
      CanvasW[Create$Line]={
        CanvasClipLine[Canvas$Coord[Take[bt, 2]],
          Canvas$Range, {1}],cmd});

    CanvasDrawerLine[cmd_, dash_, bt_] := (
      CanvasW[Create$Line]={
        CanvasClipLine[Canvas$Coord[Take[bt, 2]],
          Canvas$Range, {1}],
        Dash->TclArg[Round[dash*DPI]],cmd});

    CanvasDrawerPoints[sym_ ,, ptc_, pc_, size_, pbc_, bt_] := (
      Canvas$Symbol[, Canvas$Coord[Take[bt,2]], sym,
	PlotSymbolSize * size * Sqrt[512 / Max[512, Length[First[bt]]]],
	ptc, If[Not[StringQ[pbc]], ptc, pbc]]);

    CanvasDrawerPoints[sym_ , tag_, ptc_, pc_, size_, pbc_, bt_] := Module[
      {n=Length[First[bt]], tl},
      tl=StandardForm[If[Head[tag]===List,
        If[Length[tag]==2 && NumberQ[Second[tag]],
          Table[First[tag]//i, {i, Second[tag], Second[tag]+n-1}],
          tag],
        Table[tag//i, {i, n}]]];
      (TagFrame[#]=Canvas$Frame)&/@tl;
      Canvas$Symbol[tl, Canvas$Coord[Take[bt,2]], sym,
	PlotSymbolSize * size * Sqrt[512 / Max[512, n]],
	ptc, If[Not[StringQ[pbc]], ptc, pbc]];
      ];
    ];

  Canvas$StepData[0, body_] := MapThread[Null, {body[[,{1,2}]],
    Thread[{body[[,1]], Append[Rest[body[[,2]]], body[[-1,2]]]}]}];

  Canvas$StepData[1, body_] := MapThread[Null, {body[[,{1,2}]],
    Thread[{Append[Rest[body[[,1]]], body[[-1, 1]]], body[[,2]]}]}];

  Canvas$StepData[sr_, body_] := Module[{},
    If[Not[RealQ[sr]], Return[Canvas$StepData[1, body]]];

    If[sr>1, Return[Canvas$StepData[1, body]]];
    If[sr<0, Return[Canvas$StepData[0, body]]];

    With[{xl=Drop[body[[,1]], -1], dx=Difference[body[[,1]]]},
      Return[MapThread[Null, {
	Thread[{Prepend[#, body[[1, 1]]], body[[, 2]]}],
	Thread[{Append[#, body[[-1, 1]]], body[[, 2]]}]}&
	  [xl + sr * dx]]]];
    ];

  Canvas$ErrorBarData[{Linear|Date,Linear|Date},bt_,d_]:=Take[bt,-2];
  Canvas$ErrorBarData[{Linear|Date,Log},bt_,d_]:=
    {Third[bt],
      Log[10,Restrict[1+bt[[4]]/Restrict[Second[d],EPS,Infinity],
        EPS,Infinity]]};
  Canvas$ErrorBarData[{Log,Linear|Date},bt_,d_]:=
    {Log[10,Restrict[1+Third[bt]/Restrict[First[d],EPS,Infinity],
      EPS,Infinity]],bt[[4]]};
  Canvas$ErrorBarData[{Log,Log},bt_,d_]:=
    {Log[10,Restrict[1+Third[bt]/Restrict[First[d],EPS,Infinity],
      EPS,Infinity]],
      Log[10,Restrict[1+bt[[4]]/Restrict[Second[d],EPS,Infinity],
        EPS,Infinity]]};

  With[{CanvasDrawClipLine[d1_,cmd_]:=
    (CanvasWidget[Create$Line]={
      CanvasClipLine[d1,Canvas$Range],cmd})},

    Canvas$ErrorBar[ebl_,x_,y_,0,dy_,cmd_]:=(
      CanvasDrawClipLine[
        {x+ebl*{-1,1,0,0,-1,1},y+dy*{-1,-1,-1,1,1,1}},cmd]);

    Canvas$ErrorBar[ebl_,x_,y_,dx_,dy_,cmd_]:=
      CanvasDrawClipLine[
        { x+{-ebl,ebl,0,  0,-ebl,ebl, 0,0,-dx,-dx, -dx,-dx,dx,  dx, dx},
          y+{-dy, -dy,-dy,dy,dy,  dy,dy,0, 0, -ebl,ebl,  0, 0,-ebl,ebl}},cmd];

    Canvas$ErrorBar[0,x_,y_,dx_,dy_,cmd_]:=
      CanvasDrawClipLine[{x+dx*{0,0,0,-1,1},y+dy*{-1,1,0,0,0}},cmd];

    Canvas$ErrorBar[ebl_,x_,y_,0,0,cmd_]:=
      CanvasDrawClipLine[{x+ebl*{-1,1},{y,y}},cmd];

    Canvas$ErrorBar[0,x_,y_,dx_,0,cmd_]:=
      CanvasDrawClipLine[{x+dx*{-1,1},{y,y}},cmd];

    Canvas$ErrorBar[0,x_,y_,0,dy_,cmd_]:=
      CanvasDrawClipLine[{{x,x},y+dy*{-1,1}},cmd];

    Canvas$ErrorBar[ebl_,x_,y_,dx_,0,cmd_]:=
      CanvasDrawClipLine[{x+dx*{1,1,1,-1,-1,-1},y+ebl*{-1,1,0,0,-1,1}},cmd]
    ];

  WindowBG[frid_,wc_,fr_,ib_]:=Module[
    {p=Thread[WindowCoord[Canvas$Window]],frc=If[fr,"black",wc],
      t=StandardForm["BG$"//frid]},
    CanvasWidget[Create$Rectangle]={p,Fill->wc,OutLine->frc,Width->1,Tags->t};
    If[ib && ~CanvasBind[frid],
      Bind[CanvasWidget,"<Button-1>",CanvasInfo[frid],Tags->t];
      CanvasBind[frid]=True];
    CanvasWidget[Lower] = {t}];
  WindowBG[_,,0,_]=Null;
  WindowBG[_,,fr_,_]:=(
    The$Canvas[Create$Rectangle]={Thread[WindowCoord[Canvas$Window]],
      OutLine->"black",Width->1};
    CanvasWidget[Lower] = {CanvasLastID});

  CanvasBind[_]:=False;
  CanvasInfo[fr_]:=Module[{{x,t}={{X,Y},Tag}/.$Event,
    {axes,scale,offset}=GraphicsList[[fr,1,2,{2,6,7}]],co,dx},
    Bind[CanvasWidget,"<Motion>",CanvasInfoUpdate[fr]];
    Bind[CanvasWidget,"<ButtonRelease-1>",DeleteInfo[]];
    CanvasWidget[Lower] = {t};
    CanvasWidget[Create$Rectangle] = Join[{0,0,1,1},
      {Fill->"lemonchiffon",Tags->"infobg"}];
    CanvasWidget[Create$Text] = Join[x-{0,10},
      {Text->InfoLabel[x,axes,offset,scale],Anchor->"s",Tags->"infolabel"}];
	{co,dx}=InfoBBox[];
	If[dx<=>0,CanvasWidget[Move]={"infolabel",dx,0}];
	CanvasWidget[Coords]={"infobg",co}];
  CanvasInfoUpdate[fr_]:=Module[{x={X,Y}/.$Event,
    {axes,scale,offset}=GraphicsList[[fr,1,2,{2,6,7}]],co,dx},
    CanvasWidget[ItemConfigure] =
      {"infolabel",Text->InfoLabel[x,axes,offset,scale]};
    CanvasWidget[Coords]={"infolabel",x-{0,10}};
	{co,dx}=InfoBBox[];
	If[co===Null,DeleteInfo[];Return[]];
	If[dx<=>0,CanvasWidget[Move]={"infolabel",dx,0}];
	CanvasWidget[Coords]={"infobg",co}];

  InfoBBox[]:=Module[{bb=CanvasWidget[BBox["infolabel"]],dx=0,
    w=WidgetInfo[CanvasWidget,Width]},
    If[MatchQ[bb,{_,_,_,_}],bb+={-2,-2,2,2},Return[{,}]];
    If[bb[[1]]<0, dx=-bb[[1]];bb+={dx,0,dx,0}];
	If[bb[[3]]>w, dx=w-bb[[3]];bb+={dx,0,dx,0}];
    {bb,dx}];
  DeleteInfo[]:=(Bind[CanvasWidget,"<Motion>"];
    Bind[CanvasWidget,"<ButtonRelease-1>"];
    CanvasWidget[Delete] = {"infolabel","infobg"});
  InfoLabel[x__]:=StandardForm[$FORM="10.5";
    ToString[MapThread[InvCoord,{x}]]];
  InvCoord[x_,Linear,o_,s_]:=(x-o)/s;
  InvCoord[x_,Date,o_,s_]:=DateString[(x-o)/s];
  InvCoord[x_,Log,o_,s_]:=10^((x-o)/s);

  TagFrame[_]=0;
  DragDo[_]      := False;
  DragStart[_]   := Null;
  DragMove[_]    := Null;
  DragRelease[_] := Null;
  CanvasTagBind[tag_,start_,move_,release_]:=(
    With[{bindTag=If[Head[tag]<=>List, {tag}, tag]}, Scan[(
      DragDo[#]      = True;
      DragStart[#]   = start;
      DragMove[#]    = move;
      DragRelease[#] = release;)&, bindTag]];
    Bind[CanvasWidget,"<Button-1>",CanvasDrag[],Tags->tag,Add->True]);
  CanvasTagUnbind[tag_]:=(
    With[{bindTag=If[Head[tag]<=>List, {tag}, tag]}, Scan[
      Clear[DragDo[#], DragStart[#], DragMove[#], DragRelease[#]]&, bindTag]]);
  CanvasDragCall[Null]:=Null;
  CanvasDragCall[f_]:=Module[{fr,axes,scale,offset},
    If[(fr=TagFrame[DragTag])>0 && f[DragTag]<=>Null,
      {axes,scale,offset}=GraphicsList[[fr,1,2,{2,6,7}]];
      f[DragTag][DragTag,MapThread[InvCoord,{DragZ,axes,offset,scale}]]]];
  CanvasDrag[]:=(
    If[Not[DragDo[Tag/.$Event]], Return[]];
    {DragZ,DragTag}={{X,Y},Tag}/.$Event;
    DragZ0=DragZ;
    DeleteInfo[];
    Bind[CanvasWidget,"<Motion>",CanvasMove[]];
    Bind[CanvasWidget,"<ButtonRelease-1>",CanvasRelease[]];
    Bind[CanvasWidget,"<Escape>",CanvasCancel[]];
    CanvasWidget[Focus];
    CanvasDragCall[DragStart]);
  CanvasMove[]:=Module[{x={X,Y}/.$Event},
    CanvasWidget[Move]={DragTag,x-DragZ};
    DragZ=x;
    CanvasDragCall[DragMove]];
  CanvasRelease[]:=(
    Bind[CanvasWidget,"<Motion>"];
    Bind[CanvasWidget,"<ButtonRelease-1>"];
    Bind[CanvasWidget,"<Escape>"];
    CanvasDragCall[DragRelease]);
  CanvasCancel[]:=(
    CanvasWidget[Move]={DragTag,DragZ0-DragZ};
    CanvasRelease[]);

  (* CanvasFrame CallBack *)
  CanvasFrameRegisterCallBack[frid_Real, event_String, func_] := Module[{id},
    (* Initialize CallBack table *)
    If[Head[Canvas$FrameCallBack[frid, event]]===List,
      id=First[Complement[Range[Max[Canvas$FrameCallBack[frid, event]] + 1],
	Canvas$FrameCallBack[frid, event]]],
      id=1; Canvas$FrameCallBack[frid, event]={}];
    Canvas$FrameCallBack[frid, event, id]=func;
    AppendTo[Canvas$FrameCallBack[frid, event], id];
    Return[id]];

  CanvasFrameUnregisterCallBack[frid_Real, event_String, cbid_Real] :=
    If[Head[Canvas$FrameCallBack[frid, event]]===List
      && Select[Canvas$FrameCallBack[frid, event], (#===cbid)&]<=>{},
      Canvas$FrameCallBack[frid, event]=
	Complement[Canvas$FrameCallBack[frid, event], {cbid}];
      Canvas$FrameCallBack[frid, event, cbid]=.;
      If[Canvas$FrameCallBack[frid, event]==={},
	Canvas$FrameCallBack[frid, event]=.]];
  
  CanvasFrameClearCallBack[frid_Real, event_String] :=
    If[Head[Canvas$FrameCallBack[frid, event]]===List,
      Scan[(Canvas$FrameCallBack[frid, event, #]=.)&,
	Canvas$FrameCallBack[frid, event]];
      Canvas$FrameCallBack[frid, event]=.];

  CanvasFrameScanCallBack[frid_Real, event_String, func_] :=
    If[Head[Canvas$FrameCallBack[frid, event]]===List,
      Scan[func[Canvas$FrameCallBack[frid, event, #]]&,
	Canvas$FrameCallBack[frid, event]]];

  DefaultTickFont[x_,y_]:=
    TextFont[Restrict[Round[Switch[$FontSystem,"Xft",15,_,16]*x^y],7,32],
      $DefaultSansSerifFont];


  With[{
    TickFun[ft_,a_]:=Switch[ft,
      a,
      Null[],
      {Ticks,_Function|_List},
      ft[[-1]],
      _,
      Throw[]]},

    FrameX[ftb_,ftt_,ts_,gr_,ws_,fclk_,tkf_,frt_]:=Module[
      {{tick,Mt,mt,logdt}=
        CanvasDrawerTicks[First[Canvas$PlotRange],ts/Abs[Second[Canvas$Scale]],
          StandardScale*ws,First[Canvas$Axes]],
        y,y1,tcs,
        ftag1=StandardForm["F$X1"//Canvas$Frame],
        ftag2=StandardForm["F$X2"//Canvas$Frame],
        grtag=StandardForm["G$X"//Canvas$Frame],
        fltag,
        font=Switch[tkf,
          _String,tkf,
          _List,tkf[[1]],
          _,Default]/.Default->DefaultTickFont[StandardScale*ws,0.5]},
      If[tick<=>{},
        {y,y1}=Second[Canvas$PlotRange];
        If[gr===Both || gr===Minor || gr===Major,
          Scan[
            CanvasDrawerLine[{Fill->"#606060",Stipple->"blvst1",Tag->grtag},{1},
              Canvas$GCoord[{{#,#},{y1,y}}]]&,
            Select[If[gr===Major, Mt, Join[Mt,mt]],
              Canvas$PlotRange[[1,1]]<#<Canvas$PlotRange[[1,2]]&]]];
        If[gr===Automatic || gr===Both ||gr===Major,
          Scan[
            CanvasDrawerLine[{Fill->"#a0a0a0",Stipple->"blvst",Tag->grtag},{1},
              Canvas$GCoord[{{#,#},{y1,y}}]]&,
            Select[Mt,Canvas$PlotRange[[1,1]]<#<Canvas$PlotRange[[1,2]]&]]];
        tcs=TickString[tick];
        tcs=Thread[Join[{{Canvas$PlotRange[[1,1]],0},tcs[[2]]},
          TickString[tick],
          {tcs[[-2]],{Canvas$PlotRange[[1,2]],0}}]];
        Switch[ftb,
          True|Ticks|False|Both|{Ticks,___},
          CanvasWidget[Create$Line]={Thread[Canvas$Coord1[tcs+{0,y}]],
            Width->frt,
            Tags->ftag1};
          If[fclk,
            CanvasFrameBind[Canvas$Frame,"X1"]]];
        Switch[ftt,
          True|Ticks|Both|{Ticks,___},
          CanvasWidget[Create$Line]={
            Thread[Canvas$Coord1[tcs*{1,-1}+{0,y1}]],
            Width->frt,
            Tags->ftag2};
          If[fclk,
            CanvasFrameBind[Canvas$Frame,"X2"]]];
        Catch[
          FrameTickX[TitlePosition["BOTTOM",""][[1,2]],"n",
            Mt,logdt,"L"//ftag1,font,TickFun[ftb,True|Both]]];
        Catch[
          FrameTickX[TitlePosition["TOP",""][[1,2]],"s",
            Mt,logdt,"L"//ftag2,font,TickFun[ftt,Both]]];
        ]];

    FrameY[ftl_,ftr_,ts_,gr_,ws_,fclk_,tkf_,frt_]:=Module[
      {{tick,Mt,mt,logdt}=CanvasDrawerTicks[
        Second[Canvas$PlotRange],ts/Abs[First[Canvas$Scale]],
        StandardScale*ws*1.2,Second[Canvas$Axes]],
        x,x1,tcs,
        ftag1=StandardForm["F$Y1"//Canvas$Frame],
        ftag2=StandardForm["F$Y2"//Canvas$Frame],
        grtag=StandardForm["G$Y"//Canvas$Frame],
        fltag,
        font=Switch[tkf,
          _String,tkf,
          _List,tkf[[2]],
          _,Default]/.Default->DefaultTickFont[StandardScale*ws,0.38]},
      If[tick<=>{},
        {x,x1}=First[Canvas$PlotRange];
        If[gr===Both || gr===Minor || gr===Major,
          Scan[
            CanvasDrawerLine[{Fill->"#606060",Stipple->"blhst1",Tag->grtag},{1},
              Canvas$GCoord[{{x,x1},{#,#}}]]&,
            Select[If[gr===Major, Mt, Join[mt,Mt]],
              Canvas$PlotRange[[2,1]]<#<Canvas$PlotRange[[2,2]]&]]];
        If[gr===Automatic || gr===Both ||gr===Major,
          Scan[
            CanvasDrawerLine[{Fill->"#a0a0a0",Stipple->"blhst",Tag->grtag},{1},
              Canvas$GCoord[{{x,x1},{#,#}}]]&,
            Select[Mt,Canvas$PlotRange[[2,1]]<#<Canvas$PlotRange[[2,2]]&]]];
        tcs=TickString[tick];
        tcs=Reverse[Thread[Join[{{Canvas$PlotRange[[2,1]],0},tcs[[2]]},
          TickString[tick],
          {tcs[[-2]],{Canvas$PlotRange[[2,2]],0}}]]];
        Switch[ftl,
          True|Ticks|Both|{Ticks,___},
          CanvasWidget[Create$Line]={Thread[Canvas$Coord1[tcs+{x,0}]],
            Width->frt,
            Tags->ftag1};
          If[fclk,
            CanvasFrameBind[Canvas$Frame,"Y1"]]];
        Switch[ftr,
          True|Ticks|Both|{Ticks,___},
          CanvasWidget[Create$Line]={
            Thread[Canvas$Coord1[tcs*{-1,1}+{x1,0}]],
            Width->frt,
            Tags->ftag2};
          If[fclk,
            CanvasFrameBind[Canvas$Frame,"Y2"]]];
        Catch[
          FrameTickY[TitlePosition["LEFT CENTER",""][[1,1]],"e",
            Mt,logdt,"L"//ftag1,font,TickFun[ftl,True|Both]]];
        Catch[
          FrameTickY[TitlePosition["RIGHT CENTER",""][[1,1]],"w",
            Mt,logdt,"L"//ftag2,font,TickFun[ftr,True|Both]]]
        ]];
    ];

  FtOption[x_Rule]:=x;
  FtOption[x_String]:=(Text->x);
  FtOption[x_,fm_:""]:=StandardForm[$FORM=fm;Module[{s=ToString[x]},
    Text->Which[
      s[1]===".",   "0"//s,
      s[1,2]==="-.","-0"//s[2,-1],
      True,s]]];


  FrameTickX[yy_,anc_,Mt_,logdt_,fltag_,font_,fun_List]:=
    Module[{fm,zero,s0,logt,s,sout,tag2="E"//fltag},
      StandardForm[
        Switch[First[Canvas$Axes],
          Linear|Date,
          (CanvasWidget[Create$Text] = {
            {Canvas$Coord1[{#,0}][[1]],yy},
            Null@@Override[Null@@(FtOption/@Flatten[{##2}]),
                Anchor->anc,Tags->{fltag},
                Font->font]})&@@[fun,{1}],
            Log,
            (CanvasWidget[Create$Text] = {
              {Canvas$Coord1[{Log[#,10],0}][[1]],yy},
              Null@@Override[Null@@(FtOption/@Flatten[{##2}]),
                Anchor->anc,Tags->{fltag},
                Font->font]})&@@[fun,{1}]]]];

    FrameTickY[x2_,anc_,Mt_,logdt_,fltag_,font_,fun_List]:=
      Module[{fm,zero,s0,logt,s,sout,tag2="E"//fltag},
        StandardForm[
          Switch[Second[Canvas$Axes],
            Linear|Date,
            (CanvasWidget[Create$Text] = {
              {x2,Canvas$Coord1[{0,#}][[2]]},
              Null@@Override[Null@@(FtOption/@Flatten[{##2}]),
                Font->font,Tags->{fltag},
                Anchor->anc]})&@@[fun,{1}],
            Log,
            (CanvasWidget[Create$Text] = {
              {x2,Canvas$Coord1[{0,#}][[2]]},
              Null@@Override[Null@@(FtOption/@Flatten[{##2}]),
                Font->font,Tags->{fltag},
                Anchor->anc]})&@@[fun,{1}]]]];

  FrameTickX[yy_,anc_,Mt_,logdt_,fltag_,font_,fun_:({}&)]:=
    Module[{fm,zero,s0,logt,s,sout,{texp,exps,exp}=TickExp[Mt],
      tag2="E"//fltag},
      StandardForm[
        Switch[First[Canvas$Axes],
          Linear,
          logt=Ceiling[Log[10,Max[Abs[First[Mt]],
            Abs[Mt[[Min[2,Length[Mt]]]]]]]+1e-10];
          fm=If[logdt<=texp,"S"//(Max[logt,1]-logdt+4)//"."//Max[-logdt+texp,0],""];
          zero=1E-3 * If[Length[Mt]>1,
	    Min[Abs[Difference[Mt]]],
	    Abs[Canvas$PlotRange[[2,2]] - Canvas$PlotRange[[2,1]]]];
          Scan[(
            s=FtOption[If[Abs[#]=<zero, 0, #/exp],fm][[2]];
            CanvasWidget[Create$Text] = {
              {Canvas$Coord1[{#,0}][[1]],yy},
              Null@@Override[Null@@fun[#,exp,s],
                Anchor->anc,Text->s,Tags->{fltag},
                Font->font]})&,Mt];
          If[exp<>1,
            CanvasWidget[Create$Text] = {
              {CanvasWidget[BBox[fltag]][[3]]+8,yy},
              Text->exps,
              Font->font,Tags->{tag2},
              Anchor->anc//"w"}],
          Log,
          Scan[(
            StandardForm[$FORM="";s="10`u"//#];
            CanvasWidget[Create$Text] = {
              {Canvas$Coord1[{#,0}][[1]],yy},
              Null@@Override[Null@@fun[#,1,s],
                Anchor->anc,Text->s,Tags->{fltag},
                Font->font]})&,Mt],
          Date,
          s0="";
          Scan[(s=DateString[#];
            sout=DateForm[s,s0];
            s0=s;
            CanvasWidget[Create$Text] = {
              {Canvas$Coord1[{#,0}][[1]],yy},
              Null@@Override[Null@@fun[#,1,sout],
                Anchor->anc,Text->sout,Tags->{fltag},
                Font->font]})&,Mt]]]];

  FrameTickY[x2_,anc_,Mt_,logdt_,fltag_,font_,fun_:({}&)]:=
    Module[{fm,zero,s0,logt,s,sout,{texp,exps,exp}=TickExp[Mt],
      tag2="E"//fltag},
      StandardForm[
        Switch[Second[Canvas$Axes],
          Linear,
          logt=Ceiling[Log[10,Max[Abs[First[Mt]],
            Abs[Mt[[Min[2,Length[Mt]]]]]]]+1e-10];
          fm=If[logdt<=texp,"S"//(Max[logt,1]-logdt+4)//"."//Max[-logdt+texp,0],""];
	  zero=1E-3 * If[Length[Mt]>1,
	    Min[Abs[Difference[Mt]]],
	    Abs[Canvas$PlotRange[[2,2]] - Canvas$PlotRange[[2,1]]]];
          Scan[(
            s=FtOption[If[Abs[#]=<zero, 0, #/exp],fm][[2]];
            CanvasWidget[Create$Text] = {
              {x2,Canvas$Coord1[{0,#}][[2]]},
              Null@@Override[Null@@fun[#,exp,s],
                Text->s,
                Font->font,Tags->{fltag},
                Anchor->anc]})&,Mt];
          If[exp<>1,
            CanvasWidget[Create$Text] = {
              {CanvasWidget[BBox[fltag]][[Switch[anc,"e",1,_,3]]],
                Canvas$Coord1[{0,Canvas$PlotRange[[2,2]]}][[2]]},
              Text->exps,
              Font->font,Tags->{tag2},
              Anchor->"n"//anc}],
          Log,
          Scan[(
            StandardForm[$FORM="";s="10`u"//#];
            CanvasWidget[Create$Text] = {
              {x2,Canvas$Coord1[{0,#}][[2]]},
              Null@@Override[Null@@fun[#,1,s],
                Text->s,
                Font->font,Tags->{fltag},
                Anchor->anc]})&,Mt],
          Date,
          s0="";
          Scan[(s=DateString[#];
            sout=DateForm[s,s0];
            s0=s;
            CanvasWidget[Create$Text] = {
              {x2,Canvas$Coord1[{0,#}][[2]]},
              Null@@Override[Null@@fun[#,1,sout],
                Anchor->anc,Text->sout,Tags->{fltag},
                Font->font]})&,Mt]]]];

  TickExp[Mt_]:=Module[{x=Max[Abs[Mt]]},
    If[10^5>x>10^-4,{0,"",1},
      {x=Floor[Log[10,x]],StandardForm["x10`u"//x//"`n  "],10^x}]];

  DateForm[s_,s0_]:=SuppressZero[
    If[s[12,-1]==s0[12,-1]=="00:00:00",
      Which[s[7,10]==s0[7,10],
        s[1,5],
        True,
        s[1,10]],
      Module[{sa=s[12,13]//"`uh`n"//s[15,16]//"`um`n"//s[18,19]//"`us`n"},
        If[s[18,19]==s0[18,19]=="00",
          Which[
            s[1,13]==s0[1,13],
            sa[8,14],
            s[1,10]==s0[1,10],
            If[s[15,16]==s0[15,16]=="00",
              sa[1,7],
              sa[1,14]],
            s[7,10]==s0[7,10],
            " "//sa[1,14]//"\n"//s[1,5],
            True,
            "   "//sa[1,9]//"\n"//s[1,10]],
          Which[
            s[1,13]==s0[1,13],
            sa[8,-1],
            s[1,10]==s0[1,10],
            sa,
            s[7,10]==s0[7,10],
            sa//"\n "//s[1,5],
            True,
            "   "//sa//"\n"//s[1,10]]]]]];
  SuppressZero[s_]:=If[s[1]=="0",s[2]//SuppressZero[s[3,-1]],
    Do[
      If[s[i]<>":" && (Order[s[i],"0"]>0 || Order["9",s[i]]>0),
        Return[s[1,i]//SuppressZero[s[i+1,-1]]]],
      {i,StringLength[s]}];
    s];

  CanvasDrawerTicks[{t1_,t2_},ts_,w_,Linear]:=Module[
    {dt=t2-t1,dtf,dmt,tmt,r,ts1=ts*Abs[DPI/4],tsl1,tsl2,cmt},
    If[dt<=1e-100,{{},{},{},0},
      r=dt/(dtf=10^Floor[Log[10,dt]+1e-10]);
      {dtf,dmt}=dtf*AutoTick[w,r];
      tmt=Range[Ceiling[t1/dtf]*dtf,t2,dtf];
      cmt=Complement[Range[Ceiling[t1/dmt]*dmt,t2,dmt],tmt];
      tsl1=ts1*Table[1,{Length[tmt]}];
      tsl2=ts1/3*Table[1,{Length[cmt]}];
      {Thread[{Join[tmt,cmt],Join[tsl1,tsl2]}],tmt,cmt,
        Floor[Log[10,dtf]+1e-10]}]];

  With[{lf=Append[Log[10,{1,2,3,4,5,6,7,8,9}],1],
    lf1=Log[10,{1,2,3,4,5,6,7,8,9}]},
    CanvasDrawerTicks[{t1_,t2_},ts_,w_,Log]:=Module[{dtf,
      tmt,logdt,dtf1,dtf2,i1,i2,m1,m2,j1,j2,j3,ts1=ts*Abs[DPI/4],
      tsl1,tsl2,cmt},
      If[t2-t1<=1e-40,{{},{},{},0},
        If[t2>t1+10,
          CanvasDrawerTicks[{t1,t2},ts,w,Linear],
          m1=t1-Floor[t1];
          i1=Position[lf,_?((#+1e-10>=m1)&),1,1][[1,1]];
          If[i1===1,
            j1=Floor[t1];dtf1={},
            j1=Ceiling[t1];dtf1=j1-1+Take[lf1,{i1,-1}]];
          m2=t2-Floor[t2];
          i2=Position[lf,x_?((#<=m2+1e-10)&),{1}][[-1,1]];
          If[i2==10,
            j2=Floor[t2];j3=j2+1;dtf2={},
            j3=Floor[t2];j2=j3-1;dtf2=j3+Take[lf1,{2,i2}]];
          dtf=If[j3>=j1,
            Join[dtf1,Flatten[Table[i+lf1,{i,j1,j2}]],dtf2],
            Intersection[dtf1,dtf2]];
          tmt=Range[j1,j3];
          cmt=DeleteCases[dtf,tmt,1];
          tsl1=ts1*Table[1,{Length[tmt]}];
          tsl2=ts1/3*Table[1,{Length[cmt]}];
          {Thread[{Join[tmt,cmt],Join[tsl1,tsl2]}],tmt,cmt,
            Floor[Log[10,t2-t1]+1e-10]}]]]];

  CanvasDrawerTicks[{t1_,t2_},ts_,w_,Date]:=Module[
    {dt=t2-t1,dtf,dmt,tmt,r,ts1=ts*Abs[DPI/4],tsl1,tsl2,cmt,a},
    If[dt<=1e-40,{{},{},{},0},
      r=dt/(dtf=10^Floor[Log[10,dt]+1e-10]);
      {dtf,dmt}=dtf*AutoTick[w,r];
      Which[
        dtf<50,
        ,
        dtf<200000,
        {dtf,dmt}=Switch[dtf,
          50,{60,10},
          100,{120,30},
          200,{300,60},
          500,{600,120},
          1000,{1200,300},
          2000,{1800,600},
          5000,{3600,1200},
          10000,{10800,1800},
          20000,{21600,3600},
          50000,{43200,7200},
          100000,{86400,21600},
          _,{dtf,dmt}],
        dtf<86400*5 || dtf>10000*100000,
        Return[MapAt[#*86400&,
          CanvasDrawerTicks[{t1,t2}/86400,ts,w,Linear],
          {{1,,1},{2}}]],
        True,
        {tmt,cmt}=DateTick[t1,t2,dtf];
        Goto["a"];
        ];
      tmt=Range[Ceiling[t1/dtf]*dtf,t2,dtf];
      cmt=Complement[Range[Ceiling[t1/dmt]*dmt,t2,dmt],tmt];
      Label["a"];
      tsl1=ts1*Table[1,{Length[tmt]}];
      tsl2=ts1/3*Table[1,{Length[cmt]}];
      {Thread[{Join[tmt,cmt],Join[tsl1,tsl2]}],tmt,cmt,
        Floor[Log[10,dtf]+1e-10]}]];

  DateTick[t1_,t2_,dtf_]:=Module[{da=AnchorDate[t1,t2],
    {dyf,dmf,ddf,dym,dmm,ddm}=Switch[Round[dtf/100000],
      5,{0,0,5,0,0,1},
      10,{0,0,10,0,0,2},
      20,{0,1,0,0,0,5},
      50,{0,2,0,0,0,10},
      100,{0,3,0,0,1,0},
      200,{0,6,0,0,1,0},
      500,{2,0,0,0,4,0},
      1000,{3,0,0,0,6,0},
      2000,{5,0,0,1,0,0},
      5000,{10,0,0,2,0,0},
      10000,{20,0,0,5,0,0}],
    d0,tm1,tm2,cm1,cm2,tick,tmt,cmt},
    d0=da;
    tm1=Table[d1=RoundDate[d0-{dyf,dmf,ddf,0,0,0},ddf];
      If[FromDate[d1]<t1,Break[]];
      d0=d1,{Infinity}];
    d0=da;
    tm2=Table[d1=RoundDate[d0+{dyf,dmf,ddf,0,0,0},ddf];
      If[FromDate[d1]>t2,Break[]];
      d0=d1,{Infinity}];
    tmt=Join[tm1,{da},tm2];
    d0=da;
    cm1=Table[d1=RoundDate[d0-{dym,dmm,ddm,0,0,0},ddm];
      If[FromDate[d1]<t1,Break[]];
      d0=d1,{Infinity}];
    d0=da;
    cm2=Table[d1=RoundDate[d0+{dym,dmm,ddm,0,0,0},ddm];
      If[FromDate[d1]>t2,Break[]];
      d0=d1,{Infinity}];
    tick=Join[cm1,{da},cm2];
    cmt=Complement[tick,tmt];
    {FromDate/@tmt,FromDate/@cmt}];

  With[{days = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31}}, 
    FloorToDate[t_Real] := Join[Take[ToDate[t], 3], {0, 0, 0}];
    CeilingToDate[t_Real] := With[{d = ToDate[t]}, Which[
      Drop[d, 3] === {0, 0, 0},	Join[Take[d, 3],             {0, 0, 0}],
      d[[3]] < days[[d[[2]]]],	Join[Take[d, 3] + {0, 0, 1}, {0, 0, 0}],
      True,			ToDate[FromDate[Take[d, 3] + {0, 0, 1}]]]];
    RoundDate$[d_List] := Which[
      d[[4]] < 12,		Join[Take[d, 3],             {0, 0, 0}],
      d[[3]] < days[[d[[2]]]],	Join[Take[d, 3] + {0, 0, 1}, {0, 0, 0}],
      True,			ToDate[FromDate[Take[d, 3] + {0, 0, 1}]]];
    RoundDate$[d_List, dt_Real] := With[{rd = 1 + Round[(d[[3]] - 1) / dt] * dt},
      If[rd > 30 && dt > 2,
	ToDate[FromDate[{d[[1]], d[[2]] + 1, 1}]],
	{d[[1]], d[[2]], rd, 0, 0, 0}]];

    RoundDate[d_List, dt_Real:10] := RoundDate$[RoundDate$[d], If[dt, dt, 0]];
    ];

  AnchorDate[t1_, t2_] := With[{d1 = CeilingToDate[t1], d2 = FloorToDate[t2]}, With[{d = d2 - d1}, Which[
    d[[1]],		{d1[[1]]+1,1,1,0,0,0},
    d[[2]],		{d1[[1]],d1[[2]]+1,1,0,0,0},
    d[[3]] > 10,	{d1[[1]],d1[[2]],Ceiling[(d1[[3]]-1)/10]*10+1,0,0,0},
    True,		d1]]];

  With[{
    l ={1/10,1/5, 1/2, 1,  2,  5,10},
    l1={1/50,1/20,1/10,1/5,1/2,1,2}},
    AutoTick[w_,r_]:=Module[{m=2+4.631*w+4*Min[w,0.5],j},
      j=Length[l];
      Do[If[Floor[r/l[[k]]]<m,j=k;Break[]],{k,j}];
      {l[[j]],l1[[j]]}]];

  TickString[tick_]:=
    Append[Flatten[Thread[{#,
      ReplacePart[#,0,{,2}],
      ReplacePart[Rest[tick],0,{,2}]}],1],Last[tick]]&[Drop[tick,-1]];

  ClearCanvas[]:=(CanvasWidget[Delete]="all");

  SetupCM[]:=(
    If[CCM===Null,
      CCM=CanvasCM[This]]);

  With[{def={TextSize->1,TextRotate->0,TextAlign->"w",Tags->False,
    TextJustify->Null,TextPosition->"",TextCases->"",
    TextFont->{},
    PlotColor->"Black",UseBG->False,Clip->False}},
    Primitive[Text[{"",__},___]]:=Null;
    Primitive[Text[body_,opt___]]:=Module[
      {z={TextCoord[body[[2,1]],1],TextCoord[body[[2,2]],2]},
        {size,al,pos,font,tag,tj,ca,pc,rot,ubg,clip,rota,anch,just}=
          {TextSize,TextAlign,TextPosition,TextFont,Tags,TextJustify,
            TextCases,PlotColor,TextRotate,UseBG,Clip,Rotation,Anchor,Justify}/.Override[opt,def]},
      If[~clip || (Canvas$Window[[1,1]]<=First[z]<=Canvas$Window[[1,2]]
        && Canvas$Window[[2,1]]<=Second[z]<=Canvas$Window[[2,2]]),
        ,
        Return[]];
      CanvasWidget[Create$Text] = {WindowCoord[z],
        Fill->pc,Text->First[body],
        Font->TextFont@@Flatten[{font,$DefaultSansSerifFont,Round[15*size*StandardScale]}],
        Rotation->Switch[rota,
          _Real,rota,
          _,rot],
        Rotation->rot,UseBG->ubg,
        If[StringQ[tag],Tags->tag,Null[]],
        If[tj<=>Null,Justify->tj,Switch[just,_String,Justify->just,_,Null[]]],
        Anchor->Switch[anch,
          _String,anch,
          _,AnchorString[ToLowerCase[al]]]}
      ]];

  TextCoord[z_,1]:=
    (z/.
      {Scaled[x_]:>(x*First[Canvas$Scale]+First[Canvas$Offset])/DPI,
        WindowScaled[x_]:>((x-First[Canvas$Origin])*
          First[WindowSize]/RawWindowSize[[1]]+Canvas$Window[[1,1]]),
        CanvasScaled[x_]:>x/DPI,
        RectScaled[x_]:>x*(Canvas$RawWindow[[1,2]]-Canvas$RawWindow[[1,1]])
        +Canvas$RawWindow[[1,1]],
        LeftTags[x__,dx_]:>Module[{t=StandardForm[(#//Canvas$Frame)&/@{x}],bb},
          bb=Select[CanvasWidget[BBox[#]]&/@t,#<=>{}&];
          If[bb==={},
            dx,
            Min[bb[[,1]]]/DPI-dx]],
        RightTags[x__,dx_]:>Module[{t=StandardForm[(#//Canvas$Frame)&/@{x}],bb},
          bb=Select[CanvasWidget[BBox[#]]&/@t,#<=>{}&];
          If[bb==={},
            dx,
            Max[bb[[,3]]]/DPI+dx]],
	Null[]});

  TextCoord[z_,2]:=
    (z/.
      {Scaled[y_]:>(YOrg-(y*Second[Canvas$Scale]+Second[Canvas$Offset])/DPI),
        WindowScaled[y_]:>((y-Second[Canvas$Origin])*
          Second[WindowSize]/RawWindowSize[[2]]+Canvas$Window[[2,1]]),
        CanvasScaled[y_]:>(YOrg-y/DPI),
        RectScaled[y_]:>y*(Canvas$RawWindow[[2,2]]-Canvas$RawWindow[[2,1]])
        +Canvas$RawWindow[[2,1]],
        AboveTags[y__,dy_]:>Module[{t=StandardForm[(#//Canvas$Frame)&/@{y}],bb},
          bb=Select[CanvasWidget[BBox[#]]&/@t,#<=>{}&];
          If[bb==={},
            dy,
            YOrg-Min[bb[[,2]]]/DPI+dy]],
        BelowTags[y__,dy_]:>Module[{t=StandardForm[(#//Canvas$Frame)&/@{y}],bb},
          bb=Select[CanvasWidget[BBox[#]]&/@t,#<=>{}&];
          If[bb==={},
            -dy,
            YOrg-Max[bb[[,4]]]/DPI-dy]],
	Null[]});

  AnchorString["left"]="w";
  AnchorString["right"]="e";
  AnchorString["center"]="c";
  AnchorString["top"]="n";
  AnchorString[x_]:=x;
  VerticalString[s_]:=Module[{tx=ToCharacterCode[s]},
    FromCharacterCode[Flatten[Thread[{tx,Table[10,{Length[tx]}]}]]]];

  With[{def={PointSize->1,PointSymbol->"1O",PointColor->"forest green",
    PlotColor->"black",PlotJoined->False,
    ErrorBarTickSize->1,ErrorBarThickness->1,
    PointTags->Null,PointBorderColor->Automatic,
    Legend->False,Thickness->0,Plot->True}},

    Primitive[Point[body_,opt___]]:=Module[
      {size,sym,pc,ptc,ebl,tag,pbc,leg,ebth,bt=Thread[body],
        op=Override[opt,def]},
      {size,sym,pc,ptc,ebl,tag,pbc,leg,ebth}=
        {PointSize,PointSymbol,PlotColor,PointColor,ErrorBarTickSize,PointTags,
          PointBorderColor,Legend,ErrorBarThickness}/.op;
      CanvasDrawerPoints[sym, tag, ptc, pc, size, pbc, bt];
      CanvasDrawerErrorBar[ebl * 0.1 * DPI, ebth, pc, bt];
      If[leg<=>False,
        AppendTo[LegendList[[Canvas$Frame]],
          {op,leg}]]
      ];
    Primitive[Point[{},___]]:=Null];

  With[{def={PlotColor->Null,FillColor->Null,MeshStyle->Null,Tags->False}},
    Primitive[Rectangle[min_,max_,
      opt:((_Rule|_RuleDelayed)...)]]:=(
        CanvasWidget[Create$Rectangle]={
          CoordLimited[min],
          CoordLimited[max],
          MapThread[If[StringQ[#],#2->#,Null[]]&,
            {{FillColor,MeshStyle,PlotColor,Tags}/.Override[opt,def],
              {Fill,Stipple,OutLine,Tag}}]})];

  Primitive[Rectangle[min_,max_,g__]]:=
    (Show1$[False,{min,max},g];
      {Canvas$Axes,Canvas$PlotRegion,Canvas$PlotRange,Canvas$Window}=#;
      SetCanvas$Scale[Automatic])&[
        {Canvas$Axes,Canvas$PlotRegion,Canvas$PlotRange,Canvas$Window}];

  With[{def={PlotColor->Null,FillColor->Null,MeshStyle->Null,Tags->False,
    Thickness->Null}},
    Primitive[Circle[p_,r_,
      opt:((_Rule|_RuleDelayed)...)]]:=
        (CanvasWidget[Create$Oval]={
          CoordLimited[p-r],
          CoordLimited[p+r],
          MapThread[If[Head[#]===#3,#2->#,Null[]]&,
            {{FillColor,MeshStyle,PlotColor,Tags,Thickness}/.Override[opt,def],
              {Fill,Stipple,OutLine,Tag,Width},
              {String,String,String,String,Real}}]})];

  With[{def={Plot->False, PointSize->1, PointSymbol->"1O",
    PointColor->"forest green", PointBorderColor->Automatic, PointTags->Null,
    PlotJoined->True, Thickness->1, Dashing->{1},
    PlotColor->"black", LineTags->Null,
    FillColor->Null, Tags->False}},

    Primitive[Polygon[body_, opt:((_Rule|_RuleDelayed)...)]]:=Module[
      {pl, size, sym, ptc, pbc, ptag,
	pj, thick, dash, pc, ltag, fc, tag, cmd},

      {pl, size, sym, ptc, pbc, ptag, pj, thick, dash, pc, ltag, fc, tag}=
	{Plot, PointSize, PointSymbol, PointColor, PointBorderColor, PointTags,
	  PlotJoined, Thickness, Dashing, PlotColor, LineTags,
	  FillColor, Tags}/.Override[{opt}/.{
	    Literal[The$Canvas]->The$Canvas,
	    Literal[Canvas$Frame]->Canvas$Frame}, def];

      cmd={Fill->pc,
        If[ltag<=>Null,TagFrame[ltag]=Canvas$Frame;Tags->ltag,Null[]],
        If[thick<>1,Width->thick,Null[]]};

      (* Polygon *)
      If[StringQ[fc],
	CanvasWidget[Create$Polygon]={
	  Flatten[Map[CoordLimited[#]&, body]], Fill->fc,
	  If[StringQ[tag],
	    TagFrame[tag]=Canvas$Frame;Tags->tag, Null[]]}];

      (* BorderLine *)
      If[pj===True,
	CanvasDrawerLine[cmd, dash, Thread[Append[body, First[body]]]]];

      (* Points *)
      If[pl===True,
	CanvasDrawerPoints[sym, ptag, ptc, pc, size, pbc, Thread[body]]];
      ]];

  With[{def={Command->Null}},

    Primitive[Hook[opt:((_Rule|_RuleDelayed)...)]]:=Module[{},
      Command[Literal[CanvasDrawer]]/.Override[{opt}/.{
	    Literal[The$Canvas]->The$Canvas,
	    Literal[Canvas$Frame]->Canvas$Frame}, def];
      ]];

  RedrawGraphics[fr_,opt___]:=Module[
    {op={opt},pl=Position[AllGraphics,
      Rectangle[_,_,(_Graphics|_List)..,___]],
      rl0x=Extract[GraphicsList[[fr,1,2]],{{1,1},{2,1},{6,1},{7,1}}],
      rl0y=Extract[GraphicsList[[fr,1,2]],{{1,2},{2,2},{6,2},{7,2}}],
      k=1,gl,ex,ey,p,xscale,xrange,yscale,yrange,opk,a,aopt},
    If[fr==1,
      DefaultOption[[1]]=op;
      Show[
        Initialize->Frame,
        PlotRegion->Canvas$PlotRegion,
        Null@@(op/.Permanent[x_]->x),
        Graphics@@[GraphicsList[[1,,1]],{1}]]];
    {xscale,yscale}=Scale/.op;
    {xrange,yrange}=PlotRange/.op;
    p=MapAt[
      (++k;
        Which[
          k==fr,
          DefaultOption[[fr]]=op;
          {aopt,a}=SwitchCases[List@@#,{_Rule|_RuleDelayed,_}];
          Rectangle[Null@@a,Null@@Override[opt,Null@@aopt]],
          gl=GraphicsList[[k,1,2]];
          ex=(Extract[gl,{{1,1},{2,1},{6,1},{7,1}}]===rl0x);
          ey=(Extract[gl,{{1,2},{2,2},{6,2},{7,2}}]===rl0y);
          ex (* ||ey *),
          DefaultOption[[k]]=(
            opk={
              Scale->{
                If[ex,xscale,gl[[2,1]]],
                If[ey,yscale,gl[[2,2]]]},
              PlotRange->{
                If[ex,xrange,gl[[1,1]]],
                If[ey,yrange,gl[[1,2]]]}});
          {aopt,a}=SwitchCases[List@@#,{_Rule|_RuleDelayed,_}];
          Rectangle[Null@@a,Null@@Override[Null@@opk,Null@@aopt]],
          True,
          #])&,AllGraphics,pl];
    Show[
      PlotRegion->Canvas$PlotRegion,
      Initialize->Frame,p]];

  With[{txdef={PlotColor->"black",TextFont->{},TextSize->1}},
    Canvas$Legend[n_, r_, l_] := Module[
      {pc,pl,size,sym,ptc,dash,thick,pj,pbc,pbc1,leg,cmd,x0,dx,dy,y,d,legtag,bdf,
        x1,x2,y1,y2,ls,w,h,rb,tx,txfont,txsize,txcol},

      ls = StandardForm["legend"//n];
      {w,h} = WidgetInfo[CanvasWidget,{Width,Height}];
      If [{w,h}==={1,1}, {w,h} = CanvasWidget[CGet[Width,Height]]];
      legtag = (Tags->ls);
      {x0,y} = {r[[2,1]]-200,r[[1,2]] + 30};
      dx = 40;
      d = 5;
      Scan[(
        {pc,pl,size,sym,ptc,dash,thick,pj,pbc,leg}=
          {PlotColor,Plot,PointSize,PointSymbol,
            PointColor,Dashing,Thickness,PlotJoined,
            PointBorderColor,Legend}/.First[#];
        cmd={Fill->pc,legtag,If[thick<>0,Width->thick,Null[]]};
        If [pj<=>False,
          bdf=CanvasClipLine[{{x0,x0+dx},{y,y}},{{0,0},{w,h}},{1}];
          If[dash==={1},
            CanvasWidget[Create$Line]={bdf,cmd},
            CanvasWidget[Create$Line]={bdf,Dash->TclArg[Round[dash*DPI]],cmd}]
          ];
        If [pl,
          pbc1=If[Not[StringQ[pbc]],ptc,pbc];
          size*=PlotSymbolSize;
          Canvas$Symbol[ls,{x0+dx/2,y},sym,size,ptc,pbc1];
          ];
        tx=Second[#];
        Switch[tx,
          _String,
          CanvasWidget[Create$Text] = {{x0+dx+d,y},
            Text->tx,Anchor->"w",
            Font->TextFont[$DefaultSansSerifFont,Round[15*StandardScale]],
            legtag},
          _List,
          {txfont,txsize,txcol}={TextFont,TextSize,PlotColor}/.Rest[tx]/.txdef;
          CanvasWidget[Create$Text] = {{x0+dx+d,y},
            Text->First[tx],Anchor->"w",Fill->txcol,
            Font->TextFont@@Flatten[{txfont,$DefaultSansSerifFont,Round[15*txsize*StandardScale]}],
            legtag}
          ];
        y += (CanvasWidget[BBox[ls]][[4]] - y)*2;
        )&,l];
      {x1,y1,x2,y2} = CanvasWidget[BBox[ls]];
      If[
        ({dx,dy}={r[[2,1]]-30-x2,0}+LegendOffset[ls])<=>{0,0},
        CanvasWidget[Move] = {ls, {dx,dy}};
        x1+=dx;
        x2+=dx;
        y1+=dy;
        y2+=dy];
      CanvasWidget[Create$Rectangle]={x1-d,y1-d,x2+d,y2+d,legtag};
      CanvasWidget[Create$Line]={x1-d+1,y2+d+1,x2+d+1,y2+d+1,x2+d+1,y1-d+1,
        Fill->"gray20",legtag};
      With[{ls},
        Bind[CanvasWidget,"<ButtonPress>",
          LegendStartMove[ls],legtag];
        Bind[CanvasWidget,"<ButtonRelease>",
          LegendStopMove[],legtag];
        ];
      ];
    ];
  LegendStartMove[t$_] := (
    CanvasWidget[Grab$Set];
    LegendPos = {X,Y}/.$Event;
    Bind[CanvasWidget,"<Motion>",LegendMove[t$]];
    );
  LegendStopMove[] := (
    Bind[CanvasWidget,"<Motion>",];
    CanvasWidget[Grab$Release];
    );
  LegendMove[t$_] := Module[{
    p = {X,Y}/.$Event,dp},
    LegendOffset[t$]+=(dp=p-LegendPos);
    CanvasWidget[Move] = {t$,dp};
    LegendPos = p;
    ];

  Canvas$FrameClick[fr_, axis_, opt___] := Module[
    {d=4,sc,vperm,gr,xyr,r,ax1,ax2,ay1,ay2,gl},
    gl=GraphicsList[[fr,1,2]];
    bb=Flatten[gl[[1]]*gl[[6]]+gl[[7]]];
    ax1 = bb[[1]]+2;
    ax2 = bb[[2]]-2;
    ay1 = bb[[4]]+2;
    ay2 = bb[[3]]-2;
    CanvasWidget[Create$Line]={ax1-d,ay1-d,ax2+d,ay1-d,
      ax2+d,ay2+d,ax1-d,ay2+d,ax1-d,ay1-d,
      Fill->"red",
      Tags->"axind",Stipple->"gray50"};
    CanvasWidget[Create$Line]={ax1+d,ay1+d,ax2-d,ay1+d,
      ax2-d,ay2-d,ax1+d,ay2-d,ax1+d,ay1+d,
      Fill->"red",
      Tags->"axind",Stipple->"gray50"};
    If[~ChooseAxis@Mapped,
      ChooseAxis@CAWindow=ChooseAxis[]];
    r=ChooseAxis@CAWindow@Choose[gl];
    If[r<=>Null,
      StandardForm[
        {sc,vperm,gr,xyr}=r;
	CanvasFrameScanCallBack[fr, "AxisNotify", #[{sc,vperm,gr,xyr}]&];
        Canvas$Widget=CanvasWidget;
        RedrawGraphics[fr,
          Scale->{SetPermanent[sc[[1]],vperm[[1,3]]],
            SetPermanent[sc[[2]],vperm[[2,3]]]},
          GridLines->{SetPermanent[gr[[1]],vperm[[1,4]]],
            SetPermanent[gr[[2]],vperm[[2,4]]]},
          r = Map[If[Head[#]===List,FromDate[#],#]&,xyr,{2}];
	  Do[If[vperm[[i,j]],r=MapAt[Permanent,r,{i,j}]],{i,2},{j,2}];
          PlotRange->r];
        ]];
    CanvasWidget[Delete] = "axind"];

  SetPermanent[s$_,True] := ToExpression["Permanent["//s$//"]"];
  SetPermanent[s$_,_] := s$;
  ];

CanvasGraphics@CanvasObject[_]=Null;
The$Canvas=Null;
(Canvas$Widget=Widget[c_,_Canvas])^:=(
  $DisplayFunction=CanvasDrawer;
  If[CanvasGraphics@CanvasObject[c]===Null,
    CanvasGraphics@CanvasObject[c]=CanvasGraphics[c];
    The$CanvasObject=CanvasGraphics@CanvasObject[c];
    CanvasGraphics@CanvasObject[c]@Choose[];
    CanvasGraphics@CanvasObject[c]@SetCanvas$Scale[Automatic],
    With[{CanvasGraphics@CanvasObject[c]},
      The$CanvasObject:=CanvasGraphics@CanvasObject[c];
      CanvasGraphics@CanvasObject[c]@Choose[]]]);
SetAttributes[The$CanvasObject,Dynamic];
CanvasDrawer[x__]:=The$CanvasObject@CanvasDrawer[x];
(Canvas$Offset=x_)^:=The$CanvasObject@Set$Canvas$Offset[x];
Canvas$Offset:=The$CanvasObject@Set$Canvas$Offset[];
(Canvas$Scale=x_)^:=The$CanvasObject@Set$Canvas$Scale[x];
Canvas$Scale:=The$CanvasObject@Set$Canvas$Scale[];

The$CanvasObject:=StandardForm[
  Clear[The$CanvasObject];
  If[The$Canvas===Null,
    If[StringQ[KBF$AppName],
      DefaultCanvas$Window=KBSubFrame["Canvas_"//GetPID[],DefaultCanvas$Frame],
      DefaultCanvas$Window=KBMainFrame["Canvas_"//GetPID[],DefaultCanvas$Frame]];
    DefaultCanvas$Canvas=Canvas[DefaultCanvas$Frame,
      Width->Min[WidgetInfo[DefaultCanvas$Window[$Window],ScreenWidth]*0.8,1024],
      Height->Min[WidgetInfo[DefaultCanvas$Window[$Window],ScreenHeight]*0.8,768]];
    Canvas$Widget=DefaultCanvas$Canvas,
    Canvas$Widget=The$Canvas];
  The$CanvasObject];

Canvas::busy="Canvas `1` is busy";

(* Setup FFS command backend wrapper for builtin native backend *)
FFS$DRAW;	(* Expand FFS command backend wrapper *)
Unprotect[FFS$DRAW, FFS$GEO, FFS$TDR];
FFS$DRAW[CanvasDrawer] := With[{cmd = FFS$DRAW[Command->OpticsPlot]},
  OpticsPlot@@Second[cmd];
  Update[IdleTasks];
  First[cmd]];
Protect[FFS$DRAW, FFS$GEO, FFS$TDR];

(* Add Twiss label configuration hook for OpticsPlot *)
PkgHookAdd["OpticsPlot", (
  Unprotect[Twiss$Label$Encode, Twiss$Unit$Label, Twiss$Label];

  Twiss$Label$Encode[CanvasDrawer, label_] := (
    Unprotect[Twiss$Label$Encode];
    Switch[$FontSystem,
      "Xft",	Twiss$Label$Encode[CanvasDrawer, $label_] := AdobeSymbol2UTF8[$label],
      _,	Twiss$Label$Encode[CanvasDrawer, $label_] := $label];
    Protect[Twiss$Label$Encode];
    Twiss$Label$Encode[CanvasDrawer, label]);

  Twiss$Unit$Label[CanvasDrawer, Kilometer] = "km";
  Twiss$Unit$Label[CanvasDrawer, Meter]     = "m";
  Twiss$Unit$Label[CanvasDrawer, Milimeter] = "mm";
  Twiss$Unit$Label[CanvasDrawer, Micron]    = "`fm`nm";
  Twiss$Unit$Label[CanvasDrawer, Nanometer] = "nm";

  Twiss$Unit$Label[CanvasDrawer, Radian]      = "rad";
  Twiss$Unit$Label[CanvasDrawer, Miliradian]  = "mrad";
  Twiss$Unit$Label[CanvasDrawer, Microradian] = "`fm`nrad";

  Twiss$Unit$Label[CanvasDrawer, SqrtMeter] = "`f\xD6`n`om`O";
  Twiss$Unit$Label[CanvasDrawer, SquareMeter] = "m`u2`n";
  Twiss$Unit$Label[CanvasDrawer, SquareMilimeter] = "mm`u2`n";
  Twiss$Unit$Label[CanvasDrawer, SquareMicrometer] = "`fm`nm`u2`n";

  Twiss$Unit$Label[CanvasDrawer, InvMeter] = "m`u-1`n";
  Twiss$Unit$Label[CanvasDrawer, InvKilometer] = "km`u-1`n";
  Twiss$Unit$Label[CanvasDrawer, Pi2] = "2`fp`n";
  Twiss$Unit$Label[CanvasDrawer, Ratio] = "";
  Twiss$Unit$Label[CanvasDrawer, PPM] = "ppm";
  Twiss$Unit$Label[CanvasDrawer, Percent] = "%";

  Twiss$Label[CanvasDrawer, "AX"] = "`fa`n`dx`n";
  Twiss$Label[CanvasDrawer, "BX"] = "`f\xD6`ob`n`dx`O`n";
  Twiss$Label[CanvasDrawer, "NX"] = "`fn`n`dx`n";
  Twiss$Label[CanvasDrawer, "EX"] = "`fh`n`dx`n";
  Twiss$Label[CanvasDrawer, "EPX"] = "`fh`n`dpx`n";
  Twiss$Label[CanvasDrawer, "PEX"] = "`fh`n`dxP`n";
  Twiss$Label[CanvasDrawer, "PEPX"] = "`fh`n`dpxP`n";
  Twiss$Label[CanvasDrawer, "DX"] = "`fD`nx`n";
  Twiss$Label[CanvasDrawer, "DPX"] = "`fD`np`dx`n";

  Twiss$Label[CanvasDrawer, "AY"] = "`fa`n`dy`n";
  Twiss$Label[CanvasDrawer, "BY"] = "`f\xD6`ob`n`dy`O`n";
  Twiss$Label[CanvasDrawer, "NY"] = "`fn`n`dy`n";
  Twiss$Label[CanvasDrawer, "EY"] = "`fh`n`dy`n";
  Twiss$Label[CanvasDrawer, "EPY"] = "`fh`n`dpy`n";
  Twiss$Label[CanvasDrawer, "PEY"] = "`fh`n`dyP`n";
  Twiss$Label[CanvasDrawer, "PEPY"] = "`fh`n`dpyP`n";
  Twiss$Label[CanvasDrawer, "DY"] = "`fD`ny`n";
  Twiss$Label[CanvasDrawer, "DPY"] = "`fD`np`dy`n";

  Twiss$Label[CanvasDrawer, "DZ"] = "`fD`nz`n";
  Twiss$Label[CanvasDrawer, "DDP"] = "`fD`np/p`d0`n";

  Twiss$Label[CanvasDrawer, "R1"] = "R`d1`n";
  Twiss$Label[CanvasDrawer, "R2"] = "R`d2`n";
  Twiss$Label[CanvasDrawer, "R3"] = "R`d3`n";
  Twiss$Label[CanvasDrawer, "R4"] = "R`d4`n";
  Twiss$Label[CanvasDrawer, "DETR"] = "DetR";

  Scan[Function[{key},
    Twiss$Label[CanvasDrawer, "SIG"//key|"SIZE"//key] = Switch[key,
      "DP",	"`fs`dd`n",
      _,	"`fs`n`d"//ToLowerCase[key]//"`n"]], Twiss$Axis[[, 1]]];
  Scan[Function[{key1}, Scan[Function[{key2},
    Twiss$Label[CanvasDrawer, "SIG"//key1//key2|"SIZE"//key1//key2] = Switch[{key1 == key2, key1, key2},
      {True, "DP", _},	"`fs`dd`u2`n",
      {True,    _, _},	"`fs`n`d"//ToLowerCase[key1]//"`u2`n",
      {_,    "DP", _},	"`fs`dd`n`d"//ToLowerCase[key2]//"`n",
      {_,    _, "DP"},	"`fs`n`d"//ToLowerCase[key1]//"`fd`n",
      _,		"`fs`n`d"//ToLowerCase[key1//key2]//"`n"]], Twiss$Axis[[, 1]]]], Twiss$Axis[[, 1]]];

  Protect[Twiss$Label$Encode, Twiss$Unit$Label, Twiss$Label])];
