PkgConfig$DefaultList["OpticsPlot"->{
  "PlotDivision"->80,
  }];

ListPlot;

SetAttributes[{Region,FrameHeight,Graph,Lattice,ListCoordinate,Unit,
  InfoLabel,NameFilter,LatticeRegion},
  Constant];

With[{def={
  Region:>{1,LINE["LENGTH"]},
  Initialize->True,
  PlotRegion->{{0,1},{0.1,1.1}},
  LatticeRegion->Automatic,
  FrameHeight->Automatic,
  InfoLabel->False,
  InfoBind->True,
  DisplayFunction->Default,
  Lattice->True,
  GridLines->{Automatic,Automatic}}},

  OpticsPlot[f_List,opt___]:=Module[
    {nf=Length[f],g,pr,rg,dx,init,fh,yh,yh1,i1,lr,plb,gr,op=Override[opt,def],opd},
    op = op/.{
!      Rule[sRegion->{s1_Real, s2_Real}, Region->OP$S2Position[s1,s2]],
      Rule[Region->{S[s1_Real], s2:(_Real|_String)}, Region->{Floor[OP$S2Position[s1]], s2}],
      Rule[Region->{s1:(_Real|_String), S[s2_Real]}, Region->{s1, Ceiling[OP$S2Position[s2]]}],
      Rule[Region->{S[s1_Real], S[s2_Real]}, Region->OP$S2Position[s1, s2]],
      Null[]};
    {pr,rg,init,fh,il,lr,plb,gr}={Region,PlotRegion,Initialize,FrameHeight,
      InfoLabel,LatticeRegion,PlotLabel,GridLines}/.op;
    If[Head[pr]<=>List,pr={1,pr}];
    pr=LINE["POSITION",pr]/.{0->1,{}->LINE["LENGTH"]};
    If[fh===Automatic,fh=Table[1,{nf}]/nf];
    If[Head[fh]<=>List||Length[fh]<>nf,
      Message[OpticsPlot::frameheight]];
    If[lr===Automatic,lr={-0.15,0.08}];
    yh=Plus@@fh+lr[[2]]+0.02;
    yh1=yh-First[fh];
    g={};
    g=Table[
      i1=Min[nf,i+1];
      If[fh[[i]]==0,
        Rectangle[{0,yh1},{1,yh},
          {yh,yh1}-=fh[[{i-1,i1}]];
          OpticsPlot1$[f[[i]],pr,True,
            FrameTicks->{False,False,False,True},
            TickSize->Sqrt[fh[[i-1]]],
            GridLines->{None,None},
            Frame->True,Background->False,opt]],
        Rectangle[{0,yh1},{1,yh},
          If[fh[[i1]]<>0,
            {yh,yh1}-=fh[[{i,i1}]]];
          OpticsPlot1$[f[[i]],pr,False,
            FrameTicks->
              If[i==nf||i1==nf&&fh[[i1]]==0,
                {True, True,Ticks,If[fh[[i1]],Ticks,False]},
                {Ticks,True,Ticks,If[fh[[i1]],Ticks,False]}],
            TickSize->Sqrt[fh[[i]]],
            GridLines->gr,
            Frame->True,opt]]],
      {i,nf}];
    If[Lattice/.op,
      If[il, g=MapAt[With[{slot=#}, Append[slot, Graphics[Hook[
	Command:>((OP$XRange=If[#===CanvasDrawer && RealQ[Canvas$Frame],
	  The$CanvasObject@GraphicsList[[Canvas$Frame,1,2,4,1]],
	  Null])&)]]]]&,
	g, {1,3}]];

      AppendTo[g,
        Rectangle[{0,lr[[1]]},{1,lr[[2]]},
          LatticePlot[pr,PlotRegion->rg,opt],
	  If[il, Graphics[Hook[Command:>(If[#===CanvasDrawer &&
	    RealQ[Canvas$Frame], OPBind[Canvas$Frame]]&)]], Null[]]]]];
    g=Graphics[g,Override[Background->None,Initialize->init,opt]];
    If[(DisplayFunction/.op)===Default,
      Show[g,Override[Initialize->init,opt]]];
    g
    ]];

OpticsPlot[f_,opt___]:=OpticsPlot[{f},opt___];

OP$XRange=Null;
OP$Bind[_,_]=True;
OP$Element[s_]:=With[{s1=If[s<LINE["S","^^^"],s+(LINE["S","$$$"]-LINE["S","^^^"]),s]},
  Position[LINE["S"],_?(#>=s1&),1,1]];
OP$S2Position[s1$_Real, s2$_Real:Null] := With[{
  sMod = With[{sref = LINE["S", "^^^"], circ = LINE["S", "$$$"] - LINE["S", "^^^"]},
    If[sref == 0, Mod[#, circ]&, sref + Mod[# - sref, circ]&]],
  s2p = With[{
    margin = 2 * LINE["LENGTH"] * 2^-52,	(* for double precision *)
    tbl = With[{pl = Range[LINE["LENGTH"], 1, -1]},
      MapThread[If[#1 > 0, {#3, #2, #1}, Null[]]&, Append[LINE[{"L", "S"}, pl], pl]]]},
    With[{s = #},
      Apply[(#1 + Min[1 - margin, (s - #2) / #3])&, First[Select[tbl, #[[2]] =< s&, 1]]]]&]},

  With[{s1 = sMod[s1$], s2 = If[RealQ[s2$], sMod[s2$], Null]}, Which[
    Not[RealQ[s2]],	s2p[s1],
    s1 === s2,		With[{p = Floor[s2p[s1]]}, {p, p}],
    True,		{Max[1, Floor[s2p[s1]]], Min[LINE["LENGTH"], Ceiling[s2p[s2]]]}]]];

OPBind[frid_]:=Module[{xs,ys,xo,yo,minmax},
  {xs,ys,xo,yo}=Flatten[The$CanvasObject@GraphicsList[[frid,1,2,{6,7}]]];
  minmax=The$CanvasObject@GraphicsList[[frid,1,2,4,1]];
  With[{The$Canvas,frid,xo,yo,xs,ys,minmax,xmargin=2/xs},
    OP$S[The$Canvas,frid,x_]:=(x-xo)/xs;
    OP$Y[The$Canvas,frid,y_]:=(y-yo)/ys;
    OP$InRange[The$Canvas,frid,x_]:=
      ((minmax[[1]] - xmargin =< x) && (x =< minmax[[2]] + xmargin))];
  If[OP$Bind[The$Canvas,frid],
    OP$Bind[The$Canvas,frid]=False;
    With[{The$Canvas,frid},
      Bind[The$Canvas,"<Button-1>", OP$InfoLabel[The$Canvas,frid],Add->True];
      Bind[The$Canvas,"<ButtonRelease-1>",
	(Bind[The$Canvas,"<Leave>"]; Bind[The$Canvas,"<Motion>"];
	  After[0.3,KBF$WithdrawInfoLabel[False]]),Add->True]]]];

OP$InfoLabel[canvas_Widget,frid_Real,bind_:True]:=Module[{
  l=OP$Element[OP$S[canvas,frid,X/.$Event]],
  s=OP$S[canvas,frid,X/.$Event],y=OP$Y[canvas,frid,Y/.$Event],p,tt,te,t},
  If[l<=>{} && y<1.2 && OP$InRange[canvas,frid,s],
    If[bind,
      Bind[canvas,"<Leave>", (Bind[canvas,"<Leave>"];
	Bind[canvas,"<Motion>"];
	After[0.001,KBF$WithdrawInfoLabel[False]])];
      Bind[canvas,"<Motion>",OP$InfoLabel[canvas,frid,False]]];
    p=Max[1,l[[1,1]]-1];
    te=StandardForm[$FORM="10.5";Switch[tt=LINE["TYPENAME",p],
      "BEND",   If[LINE["ANGLE",p]===0,	tt="STEER";
                "K`d0`n ="//LINE["K0",p]//" rad",
                "`fq`n ="//LINE["ANGLE",p]//" rad"],
      "QUAD",   "K`d1`n ="//LINE["K1",p]//" m`u-1`n",
      "SEXT",   "K`d2`n ="//LINE["K2",p]//" m`u-2`n",
      "OCT",    "K`d3`n ="//LINE["K3",p]//" m`u-3`n",
      "DECA",   "K`d4`n ="//LINE["K4",p]//" m`u-4`n",
      "DODECA", "K`d5`n ="//LINE["K5",p]//" m`u-5`n",
      "CAVI",   "V`dacc`n="//LINE["VOLT",p]//" V",
      "TCAVI",  "K`d0`n="//LINE["K0",p]//" rad",
      _,        ""]];
    t=StandardForm[$FORM="10.5";
      "Entrance of "//LINE["NAME",p]//":   s = "//
	LINE["S",p]-If[s<LINE["S","^^^"],LINE["S","$$$"]-LINE["S","^^^"],0]//" m"//
      If[te==="","","\n"//StringFill[tt, " ", 6]//": "//te]//
      "\n`fb`n`dx,y `n = "//Twiss["BX",p]//", "//Twiss["BY",p]//
      " m\n`fa`n`dx,y`n = "//Twiss["AX",p]//", "//Twiss["AY",p]//
      "\n`fn`n`dx,y`n = "//Twiss["NX",p]/2/Pi//", "//Twiss["NY",p]/2/Pi//
      "\n`fh`n`dx,y`n = "//Twiss["EX",p]//", "//Twiss["EY",p]//
      " m\n`fh`n`dx,y`n' = "//Twiss["EPX",p]//", "//Twiss["EPY",p]//
      "\nR`d1,2`n ="//Twiss["R1",p]//", "//Twiss["R2",p]//
      " m\nR`d3,4`n ="//Twiss["R3",p]//" m`u-1`n, "//Twiss["R2",p]
      ];
    KBF$MoveCBForInfoLabel[Twiss$Label$Encode[t]]]];

With[{def={PlotRange->Automatic,
  Dashing->{{1},{0.6,0.15},{0.3,.1},{0.15,0.08},{0.1,.08},
    {0.6, 0.08, 0.08, 0.08},{0.3, 0.08, 0.08, 0.08}},
!  Dashing->{1},
  FrameLabel->Automatic,
  PlotColor:>With[{c = PkgConfig["OpticsPlot", "OpticsPlot:PlotColors/", ToString[$DisplayFunction]]},
    If[c <=> Null, c, PkgConfig["OpticsPlot", "OpticsPlot:PlotColors"]]],
  PointColor:>With[{c = PkgConfig["OpticsPlot", "OpticsPlot:PlotColors/", ToString[$DisplayFunction]]},
    If[c <=> Null, c, PkgConfig["OpticsPlot", "OpticsPlot:PlotColors"]]],
  PointSize->{1},
  Legend->False},
  frameoptions={PlotColor,Dashing,PointColor,PointSize}},

  (* Setup OpticsPlot default parameter *)
  PkgConfig$DefaultList[
    "OpticsPlot"->{
      "OpticsPlot:PlotColors"->{"dark slate blue", "red3", "green", "violet red", "purple"},
      Null[]}];

  OpticsPlot1$[f_,pr_,right_,opt___]:=Module[
    {lf,plt,pra,fl,frame,lfr,fropt,l,unit,v,opv,min,max,am,ru,
      del,del1,leg,
      {fopt,f1}=SwitchCases[f,{_Rule|_RuleDelayed,_}]},
    lf=Length[f1];
    fopt=Override[fopt,opt,def];
    {plt,pra,fl,leg}={Plot,PlotRange,FrameLabel,Legend}/.fopt;
    If[StringQ[fl],
      fl={fl,StringFill[""," ",StringLength[fl]]}];
    frame=Thread[Prepend[
      (If[Head[fropt=#/.fopt]<=>List,fropt={fropt}];
      lfr=Length[fropt];
      With[{r=#},(r->#)&/@
        Take[Flatten[Table[fropt,{Ceiling[lf/lfr]}],1],lf]])&/@frameoptions,
      f1]];
    l=If[f1==={},{OpticsList1$[pr,{},Null@@fopt]},
      Apply[OpticsList1$[pr,##,Null@@fopt]&,frame,{1}]];
    unit=l[[1,1,2]];
    Scan[If[#[[1,2]]<=>unit,
      Message[OpticsPlot::units,Evaluate[#[[1,2]]],Evaluate[unit]]]&,l];
    l=Cases[l,{{_,unit,_,_,_},_,_},1];
    v=l[[,3]];
    opv=l[[,2]];
    {min,max}=MinMax[#[[,2]]&/@v];
    am=Switch[pra,
      {_Real, _Real},     Max[Abs[pra]],
      {Automatic, _Real}, Max[Abs[min], Abs[pra[[2]]]],
      {_Real, Automatic}, Max[Abs[pra[[1]]], Abs[max]],
      _,                  Max[Abs[min], Abs[max]]];
    unit=Optics$Unit[unit,am];
    If[(ru=Unit$Factor[unit])<>1,
      v=v/ru;
      v=MapAt[#*ru&,v,{,,1}];
      If[pra<=>Automatic,pra=If[RealQ[#],#/ru,#]&/@pra]];
    If[pra===Automatic && unit===SqrtMeter,pra={0,am*1.1}];
    If[Depth[pra]<=2,pra={l[[1,1,5]],pra}];
    {del,del1}={"",""};
    If[leg===Automatic,
      leg=l[[,1,1]]];
    If[fl===Automatic,
      fl={"",""};
      Scan[
        (If[Head[#]===List,
          fl={First[fl]//del//First[#],Second[fl]//del1//Second[#]},
          If[#<=>"",
            fl={First[fl]//del//#,Second[fl]//del1//
              StringFill[""," ",StringLength[#]]}]];
          {del,del1}={", "," "})&,l[[,1,1]]]];
    fl=Optics$FrameLabel[fl,unit];
    fl=If[right,{"","","",fl},{"",fl,"",""}];
    MapThread[ListPlot[#,
      PlotJoined->#2,PointTags->#3,
      DisplayFunction->Identity,PlotRange->pra,
      FrameLabel->fl,Legend->#5,Null@@#4,Plot->plt,Null@@fopt]&,
      {v,l[[,1,3]],l[[,1,4]],opv,leg}]
    ]];

Optics$FrameLabel[fl_,unit_]:=Module[{lu=Twiss$Unit$Label[unit]},
  If[""<=>lu<=>{"",""},
    If[Head[lu]===List,
      { First[fl]//" ("//First[lu]//")",
        Second[fl]//"  "//Second[lu]//" "},
      First[fl]//" ("//lu//")"],
    {First[fl],Second[fl]}]];

OpticsList1$[pr_,{f_,r:((_Rule|_RuleDelayed)..)},opt___]:=OpticsList1$[pr,f,r,opt];

OpticsList1$[pr_,{f_}?(Length[Dimensions[#]]>=3&),opt___]:=OpticsList1$[pr,f,opt];

OpticsList1$[{pr1_,pr2_},f_,opt___]:=Module[
  {nlat=LINE["LENGTH"],ndiv,ltotal,
    l,dl,leng,lc,unit,fl,pj,t,tags,x0,
    op=Override[opt,
      PlotDivision->PkgConfig["OpticsPlot", "PlotDivision"],
      Unit->Twiss$Unit[f],
      ListCoordinate->"POSITION",
      PlotJoined->Head[f]<=>List]},
  {ndiv,unit,lc,fl,pj,tags}=
    {PlotDivision,Unit,ListCoordinate,FrameLabel,PlotJoined,PointTags}/.op;
  {l,t}=If[pr2<=pr1,
    ndiv=Min[2048,Max[ndiv,nlat+pr2-pr1]];
    ltotal=(LINE["S",nlat]-LINE["S",1]);
    leng=LINE["S",pr2]+ltotal-LINE["S",pr1];
    dl=Max[1e-6,leng/ndiv];
    x0=LINE["S",pr1]-ltotal;
    If[MatchQ[tags,{_,_String,___}],
      MapThread[Join,
        {OpticsList[f,pr1,nlat,dl,-ltotal,lc,tags,pj<=>False],
          OpticsList[f,1,pr2,dl,0,lc,tags,pj<=>False]}],
      {Join[OpticsList[f,pr1,nlat,dl,-ltotal,lc,tags,pj<=>False][[1]],
        OpticsList[f,1,pr2,dl,0,lc,tags,pj<=>False][[1]]],tags}],
    ndiv=Min[2048,Max[ndiv,pr2-pr1]];      
      leng=LINE["S",pr2]-LINE["S",pr1];
    dl=Max[1e-6,leng/ndiv];
    x0=LINE["S",pr1];
    OpticsList[f,pr1,pr2,dl,0,lc,tags,pj<=>False]];
  {{fl/.Automatic->Twiss$Label[f],unit,pj,t,
    {x0-0.001,x0+leng+0.001}},op,l}];

OpticsList[__]={};

OpticsList[f_List,i1_,i2_,_,off_,"POSITION",tags:{_,_String,___},pj_]:=
  Module[{d=Thread[{f,tags,LINE["POSITION",f[[,1]]]}],l,t,d1,d2},
    {l,t,d}=If[pj,
      {d1,d,d2}=SelectCases[d,{#[[3]]<i1&,#[[3]]<=i2&,True&}];
      Thread[Join[If[d1<=>{},{d1[[-1]]},{}],d,If[d2<=>{},{First[d2]},{}]]],
      Thread[Select[d,i1<=#[[3]]<=i2&]]];
    If[Length[l]>0,
      {Thread[MapAt[(LINE["S",#]+off)&,Thread[l],{{1}}]],t},
      {{},{}}]];

OpticsList[f_List,i1_,i2_,_,off_,"POSITION",t_,pj_]:=
  Module[{d=Thread[{f,LINE["POSITION",f[[,1]]]}],l,d1,d2},
    {l,d}=If[pj,
      {d1,d,d2}=SelectCases[d,{#[[2]]<i1&,#[[2]]<=i2&,True&}];
      Thread[Join[If[d1<=>{},{d1[[-1]]},{}],d,If[d2<=>{},{First[d2]},{}]]],
      Thread[Select[d,i1<=#[[2]]<=i2&]]];
    If[Length[l]>0,
      {Thread[MapAt[(LINE["S",#]+off)&,Thread[l],{{1}}]],t},
      {{},t}]];

OpticsList[f_List,i1_,i2_,_,off_,"S",tags:{_,_String,___},pj_]:=
  Module[{d=Thread[{f,tags}],l,t,{s1,s2}=LINE["S",{i1,i2}],d1,d2},
    {l,t}=If[pj,
      {d1,d,d2}=SelectCases[d,{#[[1,1]]<s1&,#[[1,1]]<=s2&,True&}];
      Thread[Join[If[d1<=>{},{d1[[-1]]},{}],d,If[d2<=>{},{First[d2]},{}]]],
      Thread[Select[d,s1<=#[[1,1]]<=s2&]]];
    If[Length[l]>0,
      If[off,
        {Thread[MapAt[(#+off)&,Thread[l],{{1}}]],t},
        {l,t}],
      {{},{}}]];

OpticsList[f_List,i1_,i2_,_,off_,"S",t_,pj_]:=
  Module[{l,{s1,s2}=LINE["S",{i1,i2}],d,d1,d2},
    l=If[pj,
      {d1,d,d2}=SelectCases[f,{First[#]<s1&,First[#]<=s2&,True&}];
      Join[If[d1<=>{},{d1[[-1]]},{}],d,If[d2<=>{},{First[d2]},{}]],
      Select[f,s1<=First[#]<=s2&]];
    If[Length[l]>0,
      If[off,
        {Thread[MapAt[(#+off)&,Thread[l],{{1}}]],t},
        {l,t}],
      {{},t}]];

OpticsList[f_,i1_,i2_,dl_,off_,_,tags_,_]:=Module[{fun,ndiv},
  Which[
    f=="BX" || f =="BY",
    fun:=Sqrt[Twiss[f,#]]&,
    MemberQ[Twiss$Functions,f],
    fun:=Twiss[f,#]&,
    f=="DETR",
    fun:=(Twiss["R1",#]*Twiss["R4",#]-Twiss["R2",#]*Twiss["R3",#])&,
    LINE$FunctionsQ[f],
    fun:=LINE[f,#]&,
    True,
    If[RealQ[f],
      Message[OpticsPlot::wronglist];Return[{{0,0},{1,1}}],
      fun:=f]
    ];
  {Table[
    ndiv=If[LINE["TYPENAME",i]==="MARK", 0,
      Floor[(LINE["S",Min[i2,i+1]]-LINE["S",i])/dl]+1];
    Null@@Table[{LINE["S",i]+LINE["L",i]*j/ndiv+off,fun[i+j/ndiv]},{j,0,ndiv-1}],
    {i,i1,i2}],tags}];

With[{def={Names->"*",Tags->False,NameFilter->Identity,
  PlotRegion->{{0,1},{0,1}},ElementHeight->Automatic}},
  LatticePlot[{pr01_,pr02_},opt___]:=Module[
    {l,nlat=LINE["LENGTH"],s1=LINE["S",pr01],leng,
      {pr1,pr2}=LINE["POSITION",{pr01,pr02}],
      {n,tag,nf,pr,eh}={Names,Tags,NameFilter,PlotRegion,ElementHeight}/.
      Override[opt,def],
      yoff=-0.7,w,ltotal},
    w=pr[[1,2]]-pr[[1,1]];
    l=If[pr2<=pr1,
      ltotal=(LINE["S",nlat]-LINE["S",1]);
      s1=s1-ltotal;
      leng=LINE["S",pr2]-s1;
      Join[LatticePlot1$[{pr1,nlat},-ltotal,tag,w,eh],
        LatticePlot1$[{1,pr2},0,tag,w,eh]],
      leng=LINE["S",pr2]-s1;
      LatticePlot1$[{pr1,pr2},0,tag,w,eh]];
    l=If[StringQ[n] && n<>"",
      {l,If[pr2<=pr1,
        Join[LatticeNames[{pr1,nlat},n,-ltotal,leng/100/w,yoff,tag,nf],
          LatticeNames[{1,pr2},n,0,leng/100/w,yoff,tag,nf]],
        LatticeNames[{pr1,pr2},n,0,leng/100/w,yoff,tag,nf]]},
      {l}];
    With[{s1, leng}, Graphics[#,{DataRange->{{s1,s1+leng},{-1,1}},
      PlotRange:>With[{XRange=OP$XRange}, OP$XRange=.;
	{If[Head[XRange]===List, XRange, {s1-0.001, s1+leng+0.001}],{-1,1}}],
      Frame->False,Background->Null}]&/@l]]];

LatticeNames[{pr1_,pr2_},n_,off_,w_,yoff_,tag_,nf_]:=Module[
  {s,s0=LINE["S",pr1]+off-w*5,e=""},
  Table[
    With[{l=LINE["NAME",i]},
      If[StringMatchQ[l,n] && e<>LINE["ELEMENT",i] &&
        ((s=(LINE["S",i]+LINE["S",i+1])/2+off)>=s0),
        s0=Max[s-w/3,s0+w*1.1];
        e=LINE["ELEMENT",i];
        Text[{nf[l],{Scaled[s0],Scaled[yoff]}},
          TextRotate->270,TextSize->0.8,TextAlign->"n",UseBG->False,
          If[tag,Tags->"L$"//l,Null[],Null[]]],
        e="";Null[],e="";Null[]]],
    {i,pr1,pr2-1}]];

With[{yoff0=0.1},
  LatticePlot1$[{pr1_,pr2_},off_,tag_,wid_,eh_]:=Module[
    {type,h,si,si1,yoff,s1=LINE["S",pr1],ds,h1,v},
    ds=(LINE["S",pr2-1]-s1)/400/wid;
    Table[
      type=LINE["TYPE",i];
      h=Switch[eh[i],
        _Real,eh[i],
        _,Element$Height[type]];
      si=LINE["S",i];
      si1=LINE["S",i] + LINE["L",i];
      If[type==4 || type == 22 || si1>s1+ds || h>h1,
        With[{default = Element["DEFAULT",LINE["ELEMENT",i]]},
          v=If[default==="",0,LINE[default,i]]];
        {h1,s1}={h,si1};
        yoff=If[h>yoff0*1.1, Sign[v]*yoff0, 0.0];
        Rectangle[{si+off,yoff-h/2},{si1+off,yoff+h/2},
          FillColor->Element$Color[type,v],
          If[tag,Tags->"C$"//LINE["NAME",i],Null[],Null[]]],
        Null[],Null[]],
      {i,pr1,pr2-1}]]];

With[{def={Orbit->True,AspectRatio->1,DataRange->Default,
  SizeFunction->"SIZE"}},
  BeamPlot[loc:(_Real|_String),ax_List,opt___]:=Module[{
    orb,asp,dr,axisx,axisy,xx,yy,xy,sf,
    x0,y0,a,axis,r,sig,x,g0,g1,g2,rx,flx,ry,fly},
    {orb,asp,dr,sf}={Orbit,AspectRatio,DataRange,SizeFunction}/.Override[opt,def];
    {axisx,axisy}=If[Length[ax]>1,ToUpperCase/@Take[ax,2],{"X","Y"}];
    xx=LINE[sf//axisx//axisx,loc];
    yy=LINE[sf//axisy//axisy,loc];
    xy=LINE[sf//axisx//axisy,loc];
    {x0,y0}=Switch[orb,
      _List, orb,
      True,  Twiss[{"D"//axisx,"D"//axisy},loc],
      False, {0,0},
      _,     {0,0}];
    {sx,sy}=Sqrt[{xx,yy}];
    If[dr===Default,
      If[MemberQ[{{"X","Y"},{"Y","X"},{"PX","PY"},{"PY","PX"}},{axisx,axisy}],
        sig=Max[sx,sy];
        dr={{x0-sig,x0+sig},{y0-sig,y0+sig}},
        dr={{x0-sx,x0+sx},{y0-sy,y0+sy}}]];
    {rx,flx}=BP$FrameFactor[axisx,dr[[1]]];
    {ry,fly}=BP$FrameFactor[axisy,dr[[2]]];
    a=xy/xx;
    r=Sqrt[yy-xy^2/xx]/sx;
    xx/=rx^2;
    {x0,sx}/=rx;
    {a,r}*=(rx/ry);
    dr/={rx,ry};
    g0=ListPlot[{{x0,y0}},AspectRatio->asp,DataRange->dr,DisplayFunction->Identity,
      opt,FrameLabel->{flx,fly},PointColor->"black",PointSize->0.2];
    g1=Plot[r*Sqrt[Max[xx-(x-x0)^2,0]]+a*(x-x0)+y0,{x,x0-sx,x0+sx},
      DisplayFunction->Identity,opt];
    g2=Plot[-r*Sqrt[Max[xx-(x-x0)^2,0]]+a*(x-x0)+y0,{x,x0-sx,x0+sx},
      DisplayFunction->Identity,opt];
    Show[g0,g1,g2,AspectRatio->asp,DataRange->dr,opt]]];

BP$FrameFactor[axis_,dr_]:=Module[{
    fl=Twiss$Label["SIG"//axis],
    fu=Twiss$Unit["SIG"//axis],
    am=Max[Abs[dr]],u},
    u=Optics$Unit[fu,am];
    {Unit$Factor[u],Optics$FrameLabel[{fl,""},u]}];

Element$Height[1]=0.08;
Element$Height[2]=0.4;
Element$Height[4]=0.8;
Element$Height[6]=0.6;
Element$Height[8]=0.6;
Element$Height[10]=0.6;
Element$Height[12]=0.6;
Element$Height[21]=0.4;
Element$Height[22]:=If[?TRPT,0.5,0.8,0.8];
Element$Height[31]=0.3;
Element$Height[32]=0.3;
Element$Height[_]=0.08;

Element$Color[4,_]="limegreen";
Element$Color[2,0]="tomato";
Element$Color[2,_]="gold";
Element$Color[1,_]=Null;
Element$Color[__]="skyblue";

SetAttributes[{Meter,InvMeter,SqrtMeter,SquareMeter,Kilometer,
  Milimeter,Micron,Nanometer,Pi2,SquareMilimeter,SquareMicrometer,
  InvKilometer,Radian,Miliradian,Microradian,
  Ratio,Percent,PPM},Constant];

Unit$Factor[Kilometer]=1E3;
Unit$Factor[Milimeter]=1E-3;
Unit$Factor[Micron]=1E-6;
Unit$Factor[Nanometer]=1E-9;
Unit$Factor[InvKilometer]=1E-3;
Unit$Factor[SquareMilimeter]=1e-6;
Unit$Factor[SquareMicrometer]=1e-12;
Unit$Factor[Pi2]=2*Pi;
Unit$Factor[Miliradian]=1E-3;
Unit$Factor[Microradian]=1E-6;
Unit$Factor[PPM]=1E-6;
Unit$Factor[Percent]=1E-2;
Unit$Factor[_]=1;

Optics$Unit[unit_,am_]:=
    Switch[unit,
      Meter,
      Which[
        am<1e-6,
        Nanometer,
        am<1e-3,
        Micron,
        am<1,
        Milimeter,
        am>1000,
        Kilometer,
        True,
        Meter],
      SquareMeter,
      Which[
        am<1e-9,
        SquareMicrometer,
        am<1e-3,
        SquareMilimeter,
        True,
        SquareMeter],
      InvMeter,
      Which[am<1e-3,
        InvKilometer,
        True,
        InvMeter],
      Radian,
      Which[
        am<1e-3,
        Microradian,
        am<1,
        Miliradian,
        True,
        Radian],
      Ratio,
      Which[
        am<1e-4,
        PPM,
        am<1,
        Percent,
        True,
        Ratio],
      _,
      unit
      ];

Twiss$Axis = {"X"->Meter, "PX"->Radian, "Y"->Meter, "PY"->Radian, "Z"->Meter, "DP"->Ratio};
Twiss$Functions={"AX","BX","NX","AY","BY","NY","EX","EPX","EY","EPY",
  "R1","R2","R3","R4","DX","DPX","DY","DPY","DZ","DDP",
  "PEX","PEPX","PEY","PEPY"};

Twiss$Unit["EX"|"EY"|"R2"|"DX"|"DY"|"S"|"PEX"|"PEY"|"DZ"]=Meter;
Twiss$Unit["DPX"|"DPY"|"EPX"|"EPY"|"PEPX"|"PEPY"]=Radian;
Twiss$Unit["R3"]=InvMeter;
Twiss$Unit["BX"|"BY"]=SqrtMeter;
Twiss$Unit["NX"|"NY"]=Pi2;
Twiss$Unit["DDP"]=Ratio;
Twiss$Unit[Times[Meter, Meter]]=SquareMeter;
Twiss$Unit[Times[Meter, Radian]]=Meter;
Twiss$Unit[Times[Meter, Ratio]]=Meter;
!Twiss$Unit[Times[Radian, Radian]]=SquareRadian;
Twiss$Unit[Times[Radian, Ratio]]=Radian;
Twiss$Unit[Times[Ratio, Ratio]]=Ratio;
Twiss$Unit[unit_Symbol]:=unit;
Twiss$Unit[_]=1;

Apply[Function[{key, unit}, Twiss$Unit["SIG"//key|"SIZE"//key] = unit], Twiss$Axis, {1}];
Apply[Function[{key1, unit1}, Apply[Function[{key2, unit2},
  Twiss$Unit["SIG"//key1//key2|"SIZE"//key1//key2] = Twiss$Unit[unit1 * unit2]],
  Twiss$Axis, {1}]; Null], Twiss$Axis, {1}];

Twiss$Label$Encode[label_] := Twiss$Label$Encode[$DisplayFunction, label];
Twiss$Label$Encode[_, label_] := label;

(* $DisplayFunction dispatch *)
Twiss$Unit$Label[tag_] := Twiss$Label$Encode[$DisplayFunction, Twiss$Unit$Label[$DisplayFunction, tag]];
Twiss$Label[tag_] := Twiss$Label$Encode[$DisplayFunction, Twiss$Label[$DisplayFunction, tag]];

(* $DisplayFunction fallback *)
Twiss$Unit$Label[_, tag_] := Twiss$Unit$Label[Identity, tag];
Twiss$Label[_, tag_] := Twiss$Label[Identity, tag];

(* Default label *)
Twiss$Unit$Label[Identity, Pi2] := "2Pi";
Twiss$Unit$Label[Identity, tag_Symbol] := ToString[tag];
Twiss$Unit$Label[Identity, _] := "";
With[{alt = Alternatives@@Twiss$Functions},
  Twiss$Label[Identity, tag:alt] := tag;
  Twiss$Label[Identity, "DETR"] := "DetR"];
Twiss$Label[Identity, _] := "";

LINE$FunctionsQ[f_]:=
  MemberQ[LINE$Functions,f] || f[1,3]=="SIG" || f[1,4]=="SIZE";
LINE$Functions={"GAMMA","GAMMABETA","S"};

OpticsPlot::units="Different units in one window: `1` `2`";
OpticsPlot::frameheight=
  "FrameHeight must be a List of heights, length of number of frames";
OpticsPlot::wronglist=
  "List data must be {{x1, y1, (dy1)}, ..}";

PkgHookEvalAfter["OpticsPlot"];

Protect[OpticsPlot,OpticsPlot1$,
  Unit$Factor,Optics$Unit,Twiss$Axis,Twiss$Functions,
  Twiss$Unit,Twiss$Label$Encode,Twiss$Unit$Label,Twiss$Label,
  Element$Height,LINE$FunctionsQ,LINE$Functions,
  BeamPlot,
  OpticsList1$,OpticsList,LatticePlot,LatticePlot1$,LatticeNames];
